import json
import setuptools

kwargs = json.loads(
    """
{
    "name": "cdktf-cdktf-provider-azurerm",
    "version": "10.0.6",
    "description": "Prebuilt azurerm Provider for Terraform CDK (cdktf)",
    "license": "MPL-2.0",
    "url": "https://github.com/cdktf/cdktf-provider-azurerm.git",
    "long_description_content_type": "text/markdown",
    "author": "HashiCorp",
    "bdist_wheel": {
        "universal": true
    },
    "project_urls": {
        "Source": "https://github.com/cdktf/cdktf-provider-azurerm.git"
    },
    "package_dir": {
        "": "src"
    },
    "packages": [
        "cdktf_cdktf_provider_azurerm",
        "cdktf_cdktf_provider_azurerm._jsii",
        "cdktf_cdktf_provider_azurerm.aadb2_c_directory",
        "cdktf_cdktf_provider_azurerm.active_directory_domain_service",
        "cdktf_cdktf_provider_azurerm.active_directory_domain_service_replica_set",
        "cdktf_cdktf_provider_azurerm.active_directory_domain_service_trust",
        "cdktf_cdktf_provider_azurerm.advanced_threat_protection",
        "cdktf_cdktf_provider_azurerm.analysis_services_server",
        "cdktf_cdktf_provider_azurerm.api_connection",
        "cdktf_cdktf_provider_azurerm.api_management",
        "cdktf_cdktf_provider_azurerm.api_management_api",
        "cdktf_cdktf_provider_azurerm.api_management_api_diagnostic",
        "cdktf_cdktf_provider_azurerm.api_management_api_operation",
        "cdktf_cdktf_provider_azurerm.api_management_api_operation_policy",
        "cdktf_cdktf_provider_azurerm.api_management_api_operation_tag",
        "cdktf_cdktf_provider_azurerm.api_management_api_policy",
        "cdktf_cdktf_provider_azurerm.api_management_api_release",
        "cdktf_cdktf_provider_azurerm.api_management_api_schema",
        "cdktf_cdktf_provider_azurerm.api_management_api_tag",
        "cdktf_cdktf_provider_azurerm.api_management_api_tag_description",
        "cdktf_cdktf_provider_azurerm.api_management_api_version_set",
        "cdktf_cdktf_provider_azurerm.api_management_authorization_server",
        "cdktf_cdktf_provider_azurerm.api_management_backend",
        "cdktf_cdktf_provider_azurerm.api_management_certificate",
        "cdktf_cdktf_provider_azurerm.api_management_custom_domain",
        "cdktf_cdktf_provider_azurerm.api_management_diagnostic",
        "cdktf_cdktf_provider_azurerm.api_management_email_template",
        "cdktf_cdktf_provider_azurerm.api_management_gateway",
        "cdktf_cdktf_provider_azurerm.api_management_gateway_api",
        "cdktf_cdktf_provider_azurerm.api_management_gateway_certificate_authority",
        "cdktf_cdktf_provider_azurerm.api_management_gateway_host_name_configuration",
        "cdktf_cdktf_provider_azurerm.api_management_global_schema",
        "cdktf_cdktf_provider_azurerm.api_management_group",
        "cdktf_cdktf_provider_azurerm.api_management_group_user",
        "cdktf_cdktf_provider_azurerm.api_management_identity_provider_aad",
        "cdktf_cdktf_provider_azurerm.api_management_identity_provider_aadb2_c",
        "cdktf_cdktf_provider_azurerm.api_management_identity_provider_facebook",
        "cdktf_cdktf_provider_azurerm.api_management_identity_provider_google",
        "cdktf_cdktf_provider_azurerm.api_management_identity_provider_microsoft",
        "cdktf_cdktf_provider_azurerm.api_management_identity_provider_twitter",
        "cdktf_cdktf_provider_azurerm.api_management_logger",
        "cdktf_cdktf_provider_azurerm.api_management_named_value",
        "cdktf_cdktf_provider_azurerm.api_management_notification_recipient_email",
        "cdktf_cdktf_provider_azurerm.api_management_notification_recipient_user",
        "cdktf_cdktf_provider_azurerm.api_management_openid_connect_provider",
        "cdktf_cdktf_provider_azurerm.api_management_policy",
        "cdktf_cdktf_provider_azurerm.api_management_product",
        "cdktf_cdktf_provider_azurerm.api_management_product_api",
        "cdktf_cdktf_provider_azurerm.api_management_product_group",
        "cdktf_cdktf_provider_azurerm.api_management_product_policy",
        "cdktf_cdktf_provider_azurerm.api_management_product_tag",
        "cdktf_cdktf_provider_azurerm.api_management_redis_cache",
        "cdktf_cdktf_provider_azurerm.api_management_subscription",
        "cdktf_cdktf_provider_azurerm.api_management_tag",
        "cdktf_cdktf_provider_azurerm.api_management_user",
        "cdktf_cdktf_provider_azurerm.app_configuration",
        "cdktf_cdktf_provider_azurerm.app_configuration_feature",
        "cdktf_cdktf_provider_azurerm.app_configuration_key",
        "cdktf_cdktf_provider_azurerm.app_service",
        "cdktf_cdktf_provider_azurerm.app_service_active_slot",
        "cdktf_cdktf_provider_azurerm.app_service_certificate",
        "cdktf_cdktf_provider_azurerm.app_service_certificate_binding",
        "cdktf_cdktf_provider_azurerm.app_service_certificate_order",
        "cdktf_cdktf_provider_azurerm.app_service_connection",
        "cdktf_cdktf_provider_azurerm.app_service_custom_hostname_binding",
        "cdktf_cdktf_provider_azurerm.app_service_environment",
        "cdktf_cdktf_provider_azurerm.app_service_environment_v3",
        "cdktf_cdktf_provider_azurerm.app_service_hybrid_connection",
        "cdktf_cdktf_provider_azurerm.app_service_managed_certificate",
        "cdktf_cdktf_provider_azurerm.app_service_plan",
        "cdktf_cdktf_provider_azurerm.app_service_public_certificate",
        "cdktf_cdktf_provider_azurerm.app_service_slot",
        "cdktf_cdktf_provider_azurerm.app_service_slot_custom_hostname_binding",
        "cdktf_cdktf_provider_azurerm.app_service_slot_virtual_network_swift_connection",
        "cdktf_cdktf_provider_azurerm.app_service_source_control",
        "cdktf_cdktf_provider_azurerm.app_service_source_control_slot",
        "cdktf_cdktf_provider_azurerm.app_service_source_control_token",
        "cdktf_cdktf_provider_azurerm.app_service_virtual_network_swift_connection",
        "cdktf_cdktf_provider_azurerm.application_gateway",
        "cdktf_cdktf_provider_azurerm.application_insights",
        "cdktf_cdktf_provider_azurerm.application_insights_analytics_item",
        "cdktf_cdktf_provider_azurerm.application_insights_api_key",
        "cdktf_cdktf_provider_azurerm.application_insights_smart_detection_rule",
        "cdktf_cdktf_provider_azurerm.application_insights_standard_web_test",
        "cdktf_cdktf_provider_azurerm.application_insights_web_test",
        "cdktf_cdktf_provider_azurerm.application_insights_workbook",
        "cdktf_cdktf_provider_azurerm.application_insights_workbook_template",
        "cdktf_cdktf_provider_azurerm.application_load_balancer",
        "cdktf_cdktf_provider_azurerm.application_security_group",
        "cdktf_cdktf_provider_azurerm.arc_kubernetes_cluster",
        "cdktf_cdktf_provider_azurerm.arc_kubernetes_cluster_extension",
        "cdktf_cdktf_provider_azurerm.arc_kubernetes_flux_configuration",
        "cdktf_cdktf_provider_azurerm.arc_machine_extension",
        "cdktf_cdktf_provider_azurerm.arc_private_link_scope",
        "cdktf_cdktf_provider_azurerm.arc_resource_bridge_appliance",
        "cdktf_cdktf_provider_azurerm.attestation_provider",
        "cdktf_cdktf_provider_azurerm.automanage_configuration",
        "cdktf_cdktf_provider_azurerm.automation_account",
        "cdktf_cdktf_provider_azurerm.automation_certificate",
        "cdktf_cdktf_provider_azurerm.automation_connection",
        "cdktf_cdktf_provider_azurerm.automation_connection_certificate",
        "cdktf_cdktf_provider_azurerm.automation_connection_classic_certificate",
        "cdktf_cdktf_provider_azurerm.automation_connection_service_principal",
        "cdktf_cdktf_provider_azurerm.automation_connection_type",
        "cdktf_cdktf_provider_azurerm.automation_credential",
        "cdktf_cdktf_provider_azurerm.automation_dsc_configuration",
        "cdktf_cdktf_provider_azurerm.automation_dsc_nodeconfiguration",
        "cdktf_cdktf_provider_azurerm.automation_hybrid_runbook_worker",
        "cdktf_cdktf_provider_azurerm.automation_hybrid_runbook_worker_group",
        "cdktf_cdktf_provider_azurerm.automation_job_schedule",
        "cdktf_cdktf_provider_azurerm.automation_module",
        "cdktf_cdktf_provider_azurerm.automation_python3_package",
        "cdktf_cdktf_provider_azurerm.automation_runbook",
        "cdktf_cdktf_provider_azurerm.automation_schedule",
        "cdktf_cdktf_provider_azurerm.automation_software_update_configuration",
        "cdktf_cdktf_provider_azurerm.automation_source_control",
        "cdktf_cdktf_provider_azurerm.automation_variable_bool",
        "cdktf_cdktf_provider_azurerm.automation_variable_datetime",
        "cdktf_cdktf_provider_azurerm.automation_variable_int",
        "cdktf_cdktf_provider_azurerm.automation_variable_object",
        "cdktf_cdktf_provider_azurerm.automation_variable_string",
        "cdktf_cdktf_provider_azurerm.automation_watcher",
        "cdktf_cdktf_provider_azurerm.automation_webhook",
        "cdktf_cdktf_provider_azurerm.availability_set",
        "cdktf_cdktf_provider_azurerm.backup_container_storage_account",
        "cdktf_cdktf_provider_azurerm.backup_policy_file_share",
        "cdktf_cdktf_provider_azurerm.backup_policy_vm",
        "cdktf_cdktf_provider_azurerm.backup_policy_vm_workload",
        "cdktf_cdktf_provider_azurerm.backup_protected_file_share",
        "cdktf_cdktf_provider_azurerm.backup_protected_vm",
        "cdktf_cdktf_provider_azurerm.bastion_host",
        "cdktf_cdktf_provider_azurerm.batch_account",
        "cdktf_cdktf_provider_azurerm.batch_application",
        "cdktf_cdktf_provider_azurerm.batch_certificate",
        "cdktf_cdktf_provider_azurerm.batch_job",
        "cdktf_cdktf_provider_azurerm.batch_pool",
        "cdktf_cdktf_provider_azurerm.billing_account_cost_management_export",
        "cdktf_cdktf_provider_azurerm.blueprint_assignment",
        "cdktf_cdktf_provider_azurerm.bot_channel_alexa",
        "cdktf_cdktf_provider_azurerm.bot_channel_direct_line_speech",
        "cdktf_cdktf_provider_azurerm.bot_channel_directline",
        "cdktf_cdktf_provider_azurerm.bot_channel_email",
        "cdktf_cdktf_provider_azurerm.bot_channel_facebook",
        "cdktf_cdktf_provider_azurerm.bot_channel_line",
        "cdktf_cdktf_provider_azurerm.bot_channel_ms_teams",
        "cdktf_cdktf_provider_azurerm.bot_channel_slack",
        "cdktf_cdktf_provider_azurerm.bot_channel_sms",
        "cdktf_cdktf_provider_azurerm.bot_channel_web_chat",
        "cdktf_cdktf_provider_azurerm.bot_channels_registration",
        "cdktf_cdktf_provider_azurerm.bot_connection",
        "cdktf_cdktf_provider_azurerm.bot_service_azure_bot",
        "cdktf_cdktf_provider_azurerm.bot_web_app",
        "cdktf_cdktf_provider_azurerm.capacity_reservation",
        "cdktf_cdktf_provider_azurerm.capacity_reservation_group",
        "cdktf_cdktf_provider_azurerm.cdn_endpoint",
        "cdktf_cdktf_provider_azurerm.cdn_endpoint_custom_domain",
        "cdktf_cdktf_provider_azurerm.cdn_frontdoor_custom_domain",
        "cdktf_cdktf_provider_azurerm.cdn_frontdoor_custom_domain_association",
        "cdktf_cdktf_provider_azurerm.cdn_frontdoor_endpoint",
        "cdktf_cdktf_provider_azurerm.cdn_frontdoor_firewall_policy",
        "cdktf_cdktf_provider_azurerm.cdn_frontdoor_origin",
        "cdktf_cdktf_provider_azurerm.cdn_frontdoor_origin_group",
        "cdktf_cdktf_provider_azurerm.cdn_frontdoor_profile",
        "cdktf_cdktf_provider_azurerm.cdn_frontdoor_route",
        "cdktf_cdktf_provider_azurerm.cdn_frontdoor_route_disable_link_to_default_domain",
        "cdktf_cdktf_provider_azurerm.cdn_frontdoor_rule",
        "cdktf_cdktf_provider_azurerm.cdn_frontdoor_rule_set",
        "cdktf_cdktf_provider_azurerm.cdn_frontdoor_secret",
        "cdktf_cdktf_provider_azurerm.cdn_frontdoor_security_policy",
        "cdktf_cdktf_provider_azurerm.cdn_profile",
        "cdktf_cdktf_provider_azurerm.cognitive_account",
        "cdktf_cdktf_provider_azurerm.cognitive_account_customer_managed_key",
        "cdktf_cdktf_provider_azurerm.cognitive_deployment",
        "cdktf_cdktf_provider_azurerm.communication_service",
        "cdktf_cdktf_provider_azurerm.confidential_ledger",
        "cdktf_cdktf_provider_azurerm.consumption_budget_management_group",
        "cdktf_cdktf_provider_azurerm.consumption_budget_resource_group",
        "cdktf_cdktf_provider_azurerm.consumption_budget_subscription",
        "cdktf_cdktf_provider_azurerm.container_app",
        "cdktf_cdktf_provider_azurerm.container_app_environment",
        "cdktf_cdktf_provider_azurerm.container_app_environment_certificate",
        "cdktf_cdktf_provider_azurerm.container_app_environment_dapr_component",
        "cdktf_cdktf_provider_azurerm.container_app_environment_storage",
        "cdktf_cdktf_provider_azurerm.container_connected_registry",
        "cdktf_cdktf_provider_azurerm.container_group",
        "cdktf_cdktf_provider_azurerm.container_registry",
        "cdktf_cdktf_provider_azurerm.container_registry_agent_pool",
        "cdktf_cdktf_provider_azurerm.container_registry_scope_map",
        "cdktf_cdktf_provider_azurerm.container_registry_task",
        "cdktf_cdktf_provider_azurerm.container_registry_task_schedule_run_now",
        "cdktf_cdktf_provider_azurerm.container_registry_token",
        "cdktf_cdktf_provider_azurerm.container_registry_token_password",
        "cdktf_cdktf_provider_azurerm.container_registry_webhook",
        "cdktf_cdktf_provider_azurerm.cosmosdb_account",
        "cdktf_cdktf_provider_azurerm.cosmosdb_cassandra_cluster",
        "cdktf_cdktf_provider_azurerm.cosmosdb_cassandra_datacenter",
        "cdktf_cdktf_provider_azurerm.cosmosdb_cassandra_keyspace",
        "cdktf_cdktf_provider_azurerm.cosmosdb_cassandra_table",
        "cdktf_cdktf_provider_azurerm.cosmosdb_gremlin_database",
        "cdktf_cdktf_provider_azurerm.cosmosdb_gremlin_graph",
        "cdktf_cdktf_provider_azurerm.cosmosdb_mongo_collection",
        "cdktf_cdktf_provider_azurerm.cosmosdb_mongo_database",
        "cdktf_cdktf_provider_azurerm.cosmosdb_mongo_role_definition",
        "cdktf_cdktf_provider_azurerm.cosmosdb_mongo_user_definition",
        "cdktf_cdktf_provider_azurerm.cosmosdb_notebook_workspace",
        "cdktf_cdktf_provider_azurerm.cosmosdb_postgresql_cluster",
        "cdktf_cdktf_provider_azurerm.cosmosdb_postgresql_coordinator_configuration",
        "cdktf_cdktf_provider_azurerm.cosmosdb_postgresql_firewall_rule",
        "cdktf_cdktf_provider_azurerm.cosmosdb_postgresql_node_configuration",
        "cdktf_cdktf_provider_azurerm.cosmosdb_postgresql_role",
        "cdktf_cdktf_provider_azurerm.cosmosdb_sql_container",
        "cdktf_cdktf_provider_azurerm.cosmosdb_sql_database",
        "cdktf_cdktf_provider_azurerm.cosmosdb_sql_dedicated_gateway",
        "cdktf_cdktf_provider_azurerm.cosmosdb_sql_function",
        "cdktf_cdktf_provider_azurerm.cosmosdb_sql_role_assignment",
        "cdktf_cdktf_provider_azurerm.cosmosdb_sql_role_definition",
        "cdktf_cdktf_provider_azurerm.cosmosdb_sql_stored_procedure",
        "cdktf_cdktf_provider_azurerm.cosmosdb_sql_trigger",
        "cdktf_cdktf_provider_azurerm.cosmosdb_table",
        "cdktf_cdktf_provider_azurerm.cost_anomaly_alert",
        "cdktf_cdktf_provider_azurerm.cost_management_scheduled_action",
        "cdktf_cdktf_provider_azurerm.custom_ip_prefix",
        "cdktf_cdktf_provider_azurerm.custom_provider",
        "cdktf_cdktf_provider_azurerm.dashboard",
        "cdktf_cdktf_provider_azurerm.dashboard_grafana",
        "cdktf_cdktf_provider_azurerm.data_azurerm_aadb2_c_directory",
        "cdktf_cdktf_provider_azurerm.data_azurerm_active_directory_domain_service",
        "cdktf_cdktf_provider_azurerm.data_azurerm_advisor_recommendations",
        "cdktf_cdktf_provider_azurerm.data_azurerm_api_management",
        "cdktf_cdktf_provider_azurerm.data_azurerm_api_management_api",
        "cdktf_cdktf_provider_azurerm.data_azurerm_api_management_api_version_set",
        "cdktf_cdktf_provider_azurerm.data_azurerm_api_management_gateway",
        "cdktf_cdktf_provider_azurerm.data_azurerm_api_management_gateway_host_name_configuration",
        "cdktf_cdktf_provider_azurerm.data_azurerm_api_management_group",
        "cdktf_cdktf_provider_azurerm.data_azurerm_api_management_product",
        "cdktf_cdktf_provider_azurerm.data_azurerm_api_management_user",
        "cdktf_cdktf_provider_azurerm.data_azurerm_app_configuration",
        "cdktf_cdktf_provider_azurerm.data_azurerm_app_configuration_key",
        "cdktf_cdktf_provider_azurerm.data_azurerm_app_configuration_keys",
        "cdktf_cdktf_provider_azurerm.data_azurerm_app_service",
        "cdktf_cdktf_provider_azurerm.data_azurerm_app_service_certificate",
        "cdktf_cdktf_provider_azurerm.data_azurerm_app_service_certificate_order",
        "cdktf_cdktf_provider_azurerm.data_azurerm_app_service_environment",
        "cdktf_cdktf_provider_azurerm.data_azurerm_app_service_environment_v3",
        "cdktf_cdktf_provider_azurerm.data_azurerm_app_service_plan",
        "cdktf_cdktf_provider_azurerm.data_azurerm_application_gateway",
        "cdktf_cdktf_provider_azurerm.data_azurerm_application_insights",
        "cdktf_cdktf_provider_azurerm.data_azurerm_application_security_group",
        "cdktf_cdktf_provider_azurerm.data_azurerm_arc_machine",
        "cdktf_cdktf_provider_azurerm.data_azurerm_attestation_provider",
        "cdktf_cdktf_provider_azurerm.data_azurerm_automation_account",
        "cdktf_cdktf_provider_azurerm.data_azurerm_automation_variable_bool",
        "cdktf_cdktf_provider_azurerm.data_azurerm_automation_variable_datetime",
        "cdktf_cdktf_provider_azurerm.data_azurerm_automation_variable_int",
        "cdktf_cdktf_provider_azurerm.data_azurerm_automation_variable_object",
        "cdktf_cdktf_provider_azurerm.data_azurerm_automation_variable_string",
        "cdktf_cdktf_provider_azurerm.data_azurerm_automation_variables",
        "cdktf_cdktf_provider_azurerm.data_azurerm_availability_set",
        "cdktf_cdktf_provider_azurerm.data_azurerm_backup_policy_file_share",
        "cdktf_cdktf_provider_azurerm.data_azurerm_backup_policy_vm",
        "cdktf_cdktf_provider_azurerm.data_azurerm_bastion_host",
        "cdktf_cdktf_provider_azurerm.data_azurerm_batch_account",
        "cdktf_cdktf_provider_azurerm.data_azurerm_batch_application",
        "cdktf_cdktf_provider_azurerm.data_azurerm_batch_certificate",
        "cdktf_cdktf_provider_azurerm.data_azurerm_batch_pool",
        "cdktf_cdktf_provider_azurerm.data_azurerm_billing_enrollment_account_scope",
        "cdktf_cdktf_provider_azurerm.data_azurerm_billing_mca_account_scope",
        "cdktf_cdktf_provider_azurerm.data_azurerm_billing_mpa_account_scope",
        "cdktf_cdktf_provider_azurerm.data_azurerm_blueprint_definition",
        "cdktf_cdktf_provider_azurerm.data_azurerm_blueprint_published_version",
        "cdktf_cdktf_provider_azurerm.data_azurerm_cdn_frontdoor_custom_domain",
        "cdktf_cdktf_provider_azurerm.data_azurerm_cdn_frontdoor_endpoint",
        "cdktf_cdktf_provider_azurerm.data_azurerm_cdn_frontdoor_firewall_policy",
        "cdktf_cdktf_provider_azurerm.data_azurerm_cdn_frontdoor_origin_group",
        "cdktf_cdktf_provider_azurerm.data_azurerm_cdn_frontdoor_profile",
        "cdktf_cdktf_provider_azurerm.data_azurerm_cdn_frontdoor_rule_set",
        "cdktf_cdktf_provider_azurerm.data_azurerm_cdn_frontdoor_secret",
        "cdktf_cdktf_provider_azurerm.data_azurerm_cdn_profile",
        "cdktf_cdktf_provider_azurerm.data_azurerm_client_config",
        "cdktf_cdktf_provider_azurerm.data_azurerm_cognitive_account",
        "cdktf_cdktf_provider_azurerm.data_azurerm_communication_service",
        "cdktf_cdktf_provider_azurerm.data_azurerm_confidential_ledger",
        "cdktf_cdktf_provider_azurerm.data_azurerm_consumption_budget_resource_group",
        "cdktf_cdktf_provider_azurerm.data_azurerm_consumption_budget_subscription",
        "cdktf_cdktf_provider_azurerm.data_azurerm_container_app",
        "cdktf_cdktf_provider_azurerm.data_azurerm_container_app_environment",
        "cdktf_cdktf_provider_azurerm.data_azurerm_container_app_environment_certificate",
        "cdktf_cdktf_provider_azurerm.data_azurerm_container_group",
        "cdktf_cdktf_provider_azurerm.data_azurerm_container_registry",
        "cdktf_cdktf_provider_azurerm.data_azurerm_container_registry_scope_map",
        "cdktf_cdktf_provider_azurerm.data_azurerm_container_registry_token",
        "cdktf_cdktf_provider_azurerm.data_azurerm_cosmosdb_account",
        "cdktf_cdktf_provider_azurerm.data_azurerm_cosmosdb_mongo_database",
        "cdktf_cdktf_provider_azurerm.data_azurerm_cosmosdb_restorable_database_accounts",
        "cdktf_cdktf_provider_azurerm.data_azurerm_cosmosdb_sql_database",
        "cdktf_cdktf_provider_azurerm.data_azurerm_cosmosdb_sql_role_definition",
        "cdktf_cdktf_provider_azurerm.data_azurerm_data_factory",
        "cdktf_cdktf_provider_azurerm.data_azurerm_data_protection_backup_vault",
        "cdktf_cdktf_provider_azurerm.data_azurerm_data_share",
        "cdktf_cdktf_provider_azurerm.data_azurerm_data_share_account",
        "cdktf_cdktf_provider_azurerm.data_azurerm_data_share_dataset_blob_storage",
        "cdktf_cdktf_provider_azurerm.data_azurerm_data_share_dataset_data_lake_gen2",
        "cdktf_cdktf_provider_azurerm.data_azurerm_data_share_dataset_kusto_cluster",
        "cdktf_cdktf_provider_azurerm.data_azurerm_data_share_dataset_kusto_database",
        "cdktf_cdktf_provider_azurerm.data_azurerm_database_migration_project",
        "cdktf_cdktf_provider_azurerm.data_azurerm_database_migration_service",
        "cdktf_cdktf_provider_azurerm.data_azurerm_databox_edge_device",
        "cdktf_cdktf_provider_azurerm.data_azurerm_databricks_workspace",
        "cdktf_cdktf_provider_azurerm.data_azurerm_databricks_workspace_private_endpoint_connection",
        "cdktf_cdktf_provider_azurerm.data_azurerm_dedicated_host",
        "cdktf_cdktf_provider_azurerm.data_azurerm_dedicated_host_group",
        "cdktf_cdktf_provider_azurerm.data_azurerm_dev_test_lab",
        "cdktf_cdktf_provider_azurerm.data_azurerm_dev_test_virtual_network",
        "cdktf_cdktf_provider_azurerm.data_azurerm_digital_twins_instance",
        "cdktf_cdktf_provider_azurerm.data_azurerm_disk_access",
        "cdktf_cdktf_provider_azurerm.data_azurerm_disk_encryption_set",
        "cdktf_cdktf_provider_azurerm.data_azurerm_dns_a_record",
        "cdktf_cdktf_provider_azurerm.data_azurerm_dns_aaaa_record",
        "cdktf_cdktf_provider_azurerm.data_azurerm_dns_caa_record",
        "cdktf_cdktf_provider_azurerm.data_azurerm_dns_cname_record",
        "cdktf_cdktf_provider_azurerm.data_azurerm_dns_mx_record",
        "cdktf_cdktf_provider_azurerm.data_azurerm_dns_ns_record",
        "cdktf_cdktf_provider_azurerm.data_azurerm_dns_ptr_record",
        "cdktf_cdktf_provider_azurerm.data_azurerm_dns_soa_record",
        "cdktf_cdktf_provider_azurerm.data_azurerm_dns_srv_record",
        "cdktf_cdktf_provider_azurerm.data_azurerm_dns_txt_record",
        "cdktf_cdktf_provider_azurerm.data_azurerm_dns_zone",
        "cdktf_cdktf_provider_azurerm.data_azurerm_elastic_cloud_elasticsearch",
        "cdktf_cdktf_provider_azurerm.data_azurerm_eventgrid_domain",
        "cdktf_cdktf_provider_azurerm.data_azurerm_eventgrid_domain_topic",
        "cdktf_cdktf_provider_azurerm.data_azurerm_eventgrid_system_topic",
        "cdktf_cdktf_provider_azurerm.data_azurerm_eventgrid_topic",
        "cdktf_cdktf_provider_azurerm.data_azurerm_eventhub",
        "cdktf_cdktf_provider_azurerm.data_azurerm_eventhub_authorization_rule",
        "cdktf_cdktf_provider_azurerm.data_azurerm_eventhub_cluster",
        "cdktf_cdktf_provider_azurerm.data_azurerm_eventhub_consumer_group",
        "cdktf_cdktf_provider_azurerm.data_azurerm_eventhub_namespace",
        "cdktf_cdktf_provider_azurerm.data_azurerm_eventhub_namespace_authorization_rule",
        "cdktf_cdktf_provider_azurerm.data_azurerm_eventhub_sas",
        "cdktf_cdktf_provider_azurerm.data_azurerm_express_route_circuit",
        "cdktf_cdktf_provider_azurerm.data_azurerm_extended_locations",
        "cdktf_cdktf_provider_azurerm.data_azurerm_firewall",
        "cdktf_cdktf_provider_azurerm.data_azurerm_firewall_policy",
        "cdktf_cdktf_provider_azurerm.data_azurerm_function_app",
        "cdktf_cdktf_provider_azurerm.data_azurerm_function_app_host_keys",
        "cdktf_cdktf_provider_azurerm.data_azurerm_hdinsight_cluster",
        "cdktf_cdktf_provider_azurerm.data_azurerm_healthcare_dicom_service",
        "cdktf_cdktf_provider_azurerm.data_azurerm_healthcare_fhir_service",
        "cdktf_cdktf_provider_azurerm.data_azurerm_healthcare_medtech_service",
        "cdktf_cdktf_provider_azurerm.data_azurerm_healthcare_service",
        "cdktf_cdktf_provider_azurerm.data_azurerm_healthcare_workspace",
        "cdktf_cdktf_provider_azurerm.data_azurerm_hybrid_compute_machine",
        "cdktf_cdktf_provider_azurerm.data_azurerm_image",
        "cdktf_cdktf_provider_azurerm.data_azurerm_images",
        "cdktf_cdktf_provider_azurerm.data_azurerm_iothub",
        "cdktf_cdktf_provider_azurerm.data_azurerm_iothub_dps",
        "cdktf_cdktf_provider_azurerm.data_azurerm_iothub_dps_shared_access_policy",
        "cdktf_cdktf_provider_azurerm.data_azurerm_iothub_shared_access_policy",
        "cdktf_cdktf_provider_azurerm.data_azurerm_ip_group",
        "cdktf_cdktf_provider_azurerm.data_azurerm_key_vault",
        "cdktf_cdktf_provider_azurerm.data_azurerm_key_vault_access_policy",
        "cdktf_cdktf_provider_azurerm.data_azurerm_key_vault_certificate",
        "cdktf_cdktf_provider_azurerm.data_azurerm_key_vault_certificate_data",
        "cdktf_cdktf_provider_azurerm.data_azurerm_key_vault_certificate_issuer",
        "cdktf_cdktf_provider_azurerm.data_azurerm_key_vault_certificates",
        "cdktf_cdktf_provider_azurerm.data_azurerm_key_vault_encrypted_value",
        "cdktf_cdktf_provider_azurerm.data_azurerm_key_vault_key",
        "cdktf_cdktf_provider_azurerm.data_azurerm_key_vault_managed_hardware_security_module",
        "cdktf_cdktf_provider_azurerm.data_azurerm_key_vault_secret",
        "cdktf_cdktf_provider_azurerm.data_azurerm_key_vault_secrets",
        "cdktf_cdktf_provider_azurerm.data_azurerm_kubernetes_cluster",
        "cdktf_cdktf_provider_azurerm.data_azurerm_kubernetes_cluster_node_pool",
        "cdktf_cdktf_provider_azurerm.data_azurerm_kubernetes_node_pool_snapshot",
        "cdktf_cdktf_provider_azurerm.data_azurerm_kubernetes_service_versions",
        "cdktf_cdktf_provider_azurerm.data_azurerm_kusto_cluster",
        "cdktf_cdktf_provider_azurerm.data_azurerm_kusto_database",
        "cdktf_cdktf_provider_azurerm.data_azurerm_lb",
        "cdktf_cdktf_provider_azurerm.data_azurerm_lb_backend_address_pool",
        "cdktf_cdktf_provider_azurerm.data_azurerm_lb_outbound_rule",
        "cdktf_cdktf_provider_azurerm.data_azurerm_lb_rule",
        "cdktf_cdktf_provider_azurerm.data_azurerm_linux_function_app",
        "cdktf_cdktf_provider_azurerm.data_azurerm_linux_web_app",
        "cdktf_cdktf_provider_azurerm.data_azurerm_local_network_gateway",
        "cdktf_cdktf_provider_azurerm.data_azurerm_log_analytics_workspace",
        "cdktf_cdktf_provider_azurerm.data_azurerm_logic_app_integration_account",
        "cdktf_cdktf_provider_azurerm.data_azurerm_logic_app_standard",
        "cdktf_cdktf_provider_azurerm.data_azurerm_logic_app_workflow",
        "cdktf_cdktf_provider_azurerm.data_azurerm_machine_learning_workspace",
        "cdktf_cdktf_provider_azurerm.data_azurerm_maintenance_configuration",
        "cdktf_cdktf_provider_azurerm.data_azurerm_managed_api",
        "cdktf_cdktf_provider_azurerm.data_azurerm_managed_application_definition",
        "cdktf_cdktf_provider_azurerm.data_azurerm_managed_disk",
        "cdktf_cdktf_provider_azurerm.data_azurerm_management_group",
        "cdktf_cdktf_provider_azurerm.data_azurerm_management_group_template_deployment",
        "cdktf_cdktf_provider_azurerm.data_azurerm_maps_account",
        "cdktf_cdktf_provider_azurerm.data_azurerm_mariadb_server",
        "cdktf_cdktf_provider_azurerm.data_azurerm_marketplace_agreement",
        "cdktf_cdktf_provider_azurerm.data_azurerm_mobile_network",
        "cdktf_cdktf_provider_azurerm.data_azurerm_mobile_network_attached_data_network",
        "cdktf_cdktf_provider_azurerm.data_azurerm_mobile_network_data_network",
        "cdktf_cdktf_provider_azurerm.data_azurerm_mobile_network_packet_core_control_plane",
        "cdktf_cdktf_provider_azurerm.data_azurerm_mobile_network_packet_core_data_plane",
        "cdktf_cdktf_provider_azurerm.data_azurerm_mobile_network_service",
        "cdktf_cdktf_provider_azurerm.data_azurerm_mobile_network_sim",
        "cdktf_cdktf_provider_azurerm.data_azurerm_mobile_network_sim_group",
        "cdktf_cdktf_provider_azurerm.data_azurerm_mobile_network_sim_policy",
        "cdktf_cdktf_provider_azurerm.data_azurerm_mobile_network_site",
        "cdktf_cdktf_provider_azurerm.data_azurerm_mobile_network_slice",
        "cdktf_cdktf_provider_azurerm.data_azurerm_monitor_action_group",
        "cdktf_cdktf_provider_azurerm.data_azurerm_monitor_data_collection_endpoint",
        "cdktf_cdktf_provider_azurerm.data_azurerm_monitor_data_collection_rule",
        "cdktf_cdktf_provider_azurerm.data_azurerm_monitor_diagnostic_categories",
        "cdktf_cdktf_provider_azurerm.data_azurerm_monitor_log_profile",
        "cdktf_cdktf_provider_azurerm.data_azurerm_monitor_scheduled_query_rules_alert",
        "cdktf_cdktf_provider_azurerm.data_azurerm_monitor_scheduled_query_rules_log",
        "cdktf_cdktf_provider_azurerm.data_azurerm_mssql_database",
        "cdktf_cdktf_provider_azurerm.data_azurerm_mssql_elasticpool",
        "cdktf_cdktf_provider_azurerm.data_azurerm_mssql_managed_instance",
        "cdktf_cdktf_provider_azurerm.data_azurerm_mssql_server",
        "cdktf_cdktf_provider_azurerm.data_azurerm_mysql_flexible_server",
        "cdktf_cdktf_provider_azurerm.data_azurerm_mysql_server",
        "cdktf_cdktf_provider_azurerm.data_azurerm_nat_gateway",
        "cdktf_cdktf_provider_azurerm.data_azurerm_netapp_account",
        "cdktf_cdktf_provider_azurerm.data_azurerm_netapp_pool",
        "cdktf_cdktf_provider_azurerm.data_azurerm_netapp_snapshot",
        "cdktf_cdktf_provider_azurerm.data_azurerm_netapp_snapshot_policy",
        "cdktf_cdktf_provider_azurerm.data_azurerm_netapp_volume",
        "cdktf_cdktf_provider_azurerm.data_azurerm_netapp_volume_group_sap_hana",
        "cdktf_cdktf_provider_azurerm.data_azurerm_netapp_volume_quota_rule",
        "cdktf_cdktf_provider_azurerm.data_azurerm_network_ddos_protection_plan",
        "cdktf_cdktf_provider_azurerm.data_azurerm_network_interface",
        "cdktf_cdktf_provider_azurerm.data_azurerm_network_manager_network_group",
        "cdktf_cdktf_provider_azurerm.data_azurerm_network_security_group",
        "cdktf_cdktf_provider_azurerm.data_azurerm_network_service_tags",
        "cdktf_cdktf_provider_azurerm.data_azurerm_network_watcher",
        "cdktf_cdktf_provider_azurerm.data_azurerm_notification_hub",
        "cdktf_cdktf_provider_azurerm.data_azurerm_notification_hub_namespace",
        "cdktf_cdktf_provider_azurerm.data_azurerm_orchestrated_virtual_machine_scale_set",
        "cdktf_cdktf_provider_azurerm.data_azurerm_palo_alto_local_rulestack",
        "cdktf_cdktf_provider_azurerm.data_azurerm_platform_image",
        "cdktf_cdktf_provider_azurerm.data_azurerm_policy_assignment",
        "cdktf_cdktf_provider_azurerm.data_azurerm_policy_definition",
        "cdktf_cdktf_provider_azurerm.data_azurerm_policy_definition_built_in",
        "cdktf_cdktf_provider_azurerm.data_azurerm_policy_set_definition",
        "cdktf_cdktf_provider_azurerm.data_azurerm_policy_virtual_machine_configuration_assignment",
        "cdktf_cdktf_provider_azurerm.data_azurerm_portal_dashboard",
        "cdktf_cdktf_provider_azurerm.data_azurerm_postgresql_flexible_server",
        "cdktf_cdktf_provider_azurerm.data_azurerm_postgresql_server",
        "cdktf_cdktf_provider_azurerm.data_azurerm_private_dns_a_record",
        "cdktf_cdktf_provider_azurerm.data_azurerm_private_dns_aaaa_record",
        "cdktf_cdktf_provider_azurerm.data_azurerm_private_dns_cname_record",
        "cdktf_cdktf_provider_azurerm.data_azurerm_private_dns_mx_record",
        "cdktf_cdktf_provider_azurerm.data_azurerm_private_dns_ptr_record",
        "cdktf_cdktf_provider_azurerm.data_azurerm_private_dns_resolver",
        "cdktf_cdktf_provider_azurerm.data_azurerm_private_dns_resolver_dns_forwarding_ruleset",
        "cdktf_cdktf_provider_azurerm.data_azurerm_private_dns_resolver_forwarding_rule",
        "cdktf_cdktf_provider_azurerm.data_azurerm_private_dns_resolver_inbound_endpoint",
        "cdktf_cdktf_provider_azurerm.data_azurerm_private_dns_resolver_outbound_endpoint",
        "cdktf_cdktf_provider_azurerm.data_azurerm_private_dns_resolver_virtual_network_link",
        "cdktf_cdktf_provider_azurerm.data_azurerm_private_dns_soa_record",
        "cdktf_cdktf_provider_azurerm.data_azurerm_private_dns_srv_record",
        "cdktf_cdktf_provider_azurerm.data_azurerm_private_dns_txt_record",
        "cdktf_cdktf_provider_azurerm.data_azurerm_private_dns_zone",
        "cdktf_cdktf_provider_azurerm.data_azurerm_private_dns_zone_virtual_network_link",
        "cdktf_cdktf_provider_azurerm.data_azurerm_private_endpoint_connection",
        "cdktf_cdktf_provider_azurerm.data_azurerm_private_link_service",
        "cdktf_cdktf_provider_azurerm.data_azurerm_private_link_service_endpoint_connections",
        "cdktf_cdktf_provider_azurerm.data_azurerm_proximity_placement_group",
        "cdktf_cdktf_provider_azurerm.data_azurerm_public_ip",
        "cdktf_cdktf_provider_azurerm.data_azurerm_public_ip_prefix",
        "cdktf_cdktf_provider_azurerm.data_azurerm_public_ips",
        "cdktf_cdktf_provider_azurerm.data_azurerm_public_maintenance_configurations",
        "cdktf_cdktf_provider_azurerm.data_azurerm_recovery_services_vault",
        "cdktf_cdktf_provider_azurerm.data_azurerm_redis_cache",
        "cdktf_cdktf_provider_azurerm.data_azurerm_redis_enterprise_database",
        "cdktf_cdktf_provider_azurerm.data_azurerm_resource_group",
        "cdktf_cdktf_provider_azurerm.data_azurerm_resource_group_template_deployment",
        "cdktf_cdktf_provider_azurerm.data_azurerm_resources",
        "cdktf_cdktf_provider_azurerm.data_azurerm_role_definition",
        "cdktf_cdktf_provider_azurerm.data_azurerm_route_filter",
        "cdktf_cdktf_provider_azurerm.data_azurerm_route_table",
        "cdktf_cdktf_provider_azurerm.data_azurerm_search_service",
        "cdktf_cdktf_provider_azurerm.data_azurerm_sentinel_alert_rule",
        "cdktf_cdktf_provider_azurerm.data_azurerm_sentinel_alert_rule_anomaly",
        "cdktf_cdktf_provider_azurerm.data_azurerm_sentinel_alert_rule_template",
        "cdktf_cdktf_provider_azurerm.data_azurerm_service_plan",
        "cdktf_cdktf_provider_azurerm.data_azurerm_servicebus_namespace",
        "cdktf_cdktf_provider_azurerm.data_azurerm_servicebus_namespace_authorization_rule",
        "cdktf_cdktf_provider_azurerm.data_azurerm_servicebus_namespace_disaster_recovery_config",
        "cdktf_cdktf_provider_azurerm.data_azurerm_servicebus_queue",
        "cdktf_cdktf_provider_azurerm.data_azurerm_servicebus_queue_authorization_rule",
        "cdktf_cdktf_provider_azurerm.data_azurerm_servicebus_subscription",
        "cdktf_cdktf_provider_azurerm.data_azurerm_servicebus_topic",
        "cdktf_cdktf_provider_azurerm.data_azurerm_servicebus_topic_authorization_rule",
        "cdktf_cdktf_provider_azurerm.data_azurerm_shared_image",
        "cdktf_cdktf_provider_azurerm.data_azurerm_shared_image_gallery",
        "cdktf_cdktf_provider_azurerm.data_azurerm_shared_image_version",
        "cdktf_cdktf_provider_azurerm.data_azurerm_shared_image_versions",
        "cdktf_cdktf_provider_azurerm.data_azurerm_signalr_service",
        "cdktf_cdktf_provider_azurerm.data_azurerm_site_recovery_fabric",
        "cdktf_cdktf_provider_azurerm.data_azurerm_site_recovery_protection_container",
        "cdktf_cdktf_provider_azurerm.data_azurerm_site_recovery_replication_policy",
        "cdktf_cdktf_provider_azurerm.data_azurerm_site_recovery_replication_recovery_plan",
        "cdktf_cdktf_provider_azurerm.data_azurerm_snapshot",
        "cdktf_cdktf_provider_azurerm.data_azurerm_source_control_token",
        "cdktf_cdktf_provider_azurerm.data_azurerm_spatial_anchors_account",
        "cdktf_cdktf_provider_azurerm.data_azurerm_spring_cloud_app",
        "cdktf_cdktf_provider_azurerm.data_azurerm_spring_cloud_service",
        "cdktf_cdktf_provider_azurerm.data_azurerm_sql_database",
        "cdktf_cdktf_provider_azurerm.data_azurerm_sql_managed_instance",
        "cdktf_cdktf_provider_azurerm.data_azurerm_sql_server",
        "cdktf_cdktf_provider_azurerm.data_azurerm_ssh_public_key",
        "cdktf_cdktf_provider_azurerm.data_azurerm_storage_account",
        "cdktf_cdktf_provider_azurerm.data_azurerm_storage_account_blob_container_sas",
        "cdktf_cdktf_provider_azurerm.data_azurerm_storage_account_sas",
        "cdktf_cdktf_provider_azurerm.data_azurerm_storage_blob",
        "cdktf_cdktf_provider_azurerm.data_azurerm_storage_container",
        "cdktf_cdktf_provider_azurerm.data_azurerm_storage_encryption_scope",
        "cdktf_cdktf_provider_azurerm.data_azurerm_storage_management_policy",
        "cdktf_cdktf_provider_azurerm.data_azurerm_storage_share",
        "cdktf_cdktf_provider_azurerm.data_azurerm_storage_sync",
        "cdktf_cdktf_provider_azurerm.data_azurerm_storage_sync_group",
        "cdktf_cdktf_provider_azurerm.data_azurerm_storage_table_entity",
        "cdktf_cdktf_provider_azurerm.data_azurerm_stream_analytics_job",
        "cdktf_cdktf_provider_azurerm.data_azurerm_subnet",
        "cdktf_cdktf_provider_azurerm.data_azurerm_subscription",
        "cdktf_cdktf_provider_azurerm.data_azurerm_subscription_template_deployment",
        "cdktf_cdktf_provider_azurerm.data_azurerm_subscriptions",
        "cdktf_cdktf_provider_azurerm.data_azurerm_synapse_workspace",
        "cdktf_cdktf_provider_azurerm.data_azurerm_template_spec_version",
        "cdktf_cdktf_provider_azurerm.data_azurerm_tenant_template_deployment",
        "cdktf_cdktf_provider_azurerm.data_azurerm_traffic_manager_geographical_location",
        "cdktf_cdktf_provider_azurerm.data_azurerm_traffic_manager_profile",
        "cdktf_cdktf_provider_azurerm.data_azurerm_user_assigned_identity",
        "cdktf_cdktf_provider_azurerm.data_azurerm_virtual_desktop_host_pool",
        "cdktf_cdktf_provider_azurerm.data_azurerm_virtual_hub",
        "cdktf_cdktf_provider_azurerm.data_azurerm_virtual_hub_connection",
        "cdktf_cdktf_provider_azurerm.data_azurerm_virtual_hub_route_table",
        "cdktf_cdktf_provider_azurerm.data_azurerm_virtual_machine",
        "cdktf_cdktf_provider_azurerm.data_azurerm_virtual_machine_scale_set",
        "cdktf_cdktf_provider_azurerm.data_azurerm_virtual_network",
        "cdktf_cdktf_provider_azurerm.data_azurerm_virtual_network_gateway",
        "cdktf_cdktf_provider_azurerm.data_azurerm_virtual_network_gateway_connection",
        "cdktf_cdktf_provider_azurerm.data_azurerm_virtual_wan",
        "cdktf_cdktf_provider_azurerm.data_azurerm_vmware_private_cloud",
        "cdktf_cdktf_provider_azurerm.data_azurerm_vpn_gateway",
        "cdktf_cdktf_provider_azurerm.data_azurerm_web_application_firewall_policy",
        "cdktf_cdktf_provider_azurerm.data_azurerm_web_pubsub",
        "cdktf_cdktf_provider_azurerm.data_azurerm_web_pubsub_private_link_resource",
        "cdktf_cdktf_provider_azurerm.data_azurerm_windows_function_app",
        "cdktf_cdktf_provider_azurerm.data_azurerm_windows_web_app",
        "cdktf_cdktf_provider_azurerm.data_factory",
        "cdktf_cdktf_provider_azurerm.data_factory_custom_dataset",
        "cdktf_cdktf_provider_azurerm.data_factory_data_flow",
        "cdktf_cdktf_provider_azurerm.data_factory_dataset_azure_blob",
        "cdktf_cdktf_provider_azurerm.data_factory_dataset_azure_sql_table",
        "cdktf_cdktf_provider_azurerm.data_factory_dataset_binary",
        "cdktf_cdktf_provider_azurerm.data_factory_dataset_cosmosdb_sqlapi",
        "cdktf_cdktf_provider_azurerm.data_factory_dataset_delimited_text",
        "cdktf_cdktf_provider_azurerm.data_factory_dataset_http",
        "cdktf_cdktf_provider_azurerm.data_factory_dataset_json",
        "cdktf_cdktf_provider_azurerm.data_factory_dataset_mysql",
        "cdktf_cdktf_provider_azurerm.data_factory_dataset_parquet",
        "cdktf_cdktf_provider_azurerm.data_factory_dataset_postgresql",
        "cdktf_cdktf_provider_azurerm.data_factory_dataset_snowflake",
        "cdktf_cdktf_provider_azurerm.data_factory_dataset_sql_server_table",
        "cdktf_cdktf_provider_azurerm.data_factory_flowlet_data_flow",
        "cdktf_cdktf_provider_azurerm.data_factory_integration_runtime_azure",
        "cdktf_cdktf_provider_azurerm.data_factory_integration_runtime_azure_ssis",
        "cdktf_cdktf_provider_azurerm.data_factory_integration_runtime_managed",
        "cdktf_cdktf_provider_azurerm.data_factory_integration_runtime_self_hosted",
        "cdktf_cdktf_provider_azurerm.data_factory_linked_custom_service",
        "cdktf_cdktf_provider_azurerm.data_factory_linked_service_azure_blob_storage",
        "cdktf_cdktf_provider_azurerm.data_factory_linked_service_azure_databricks",
        "cdktf_cdktf_provider_azurerm.data_factory_linked_service_azure_file_storage",
        "cdktf_cdktf_provider_azurerm.data_factory_linked_service_azure_function",
        "cdktf_cdktf_provider_azurerm.data_factory_linked_service_azure_search",
        "cdktf_cdktf_provider_azurerm.data_factory_linked_service_azure_sql_database",
        "cdktf_cdktf_provider_azurerm.data_factory_linked_service_azure_table_storage",
        "cdktf_cdktf_provider_azurerm.data_factory_linked_service_cosmosdb",
        "cdktf_cdktf_provider_azurerm.data_factory_linked_service_cosmosdb_mongoapi",
        "cdktf_cdktf_provider_azurerm.data_factory_linked_service_data_lake_storage_gen2",
        "cdktf_cdktf_provider_azurerm.data_factory_linked_service_key_vault",
        "cdktf_cdktf_provider_azurerm.data_factory_linked_service_kusto",
        "cdktf_cdktf_provider_azurerm.data_factory_linked_service_mysql",
        "cdktf_cdktf_provider_azurerm.data_factory_linked_service_odata",
        "cdktf_cdktf_provider_azurerm.data_factory_linked_service_odbc",
        "cdktf_cdktf_provider_azurerm.data_factory_linked_service_postgresql",
        "cdktf_cdktf_provider_azurerm.data_factory_linked_service_sftp",
        "cdktf_cdktf_provider_azurerm.data_factory_linked_service_snowflake",
        "cdktf_cdktf_provider_azurerm.data_factory_linked_service_sql_server",
        "cdktf_cdktf_provider_azurerm.data_factory_linked_service_synapse",
        "cdktf_cdktf_provider_azurerm.data_factory_linked_service_web",
        "cdktf_cdktf_provider_azurerm.data_factory_managed_private_endpoint",
        "cdktf_cdktf_provider_azurerm.data_factory_pipeline",
        "cdktf_cdktf_provider_azurerm.data_factory_trigger_blob_event",
        "cdktf_cdktf_provider_azurerm.data_factory_trigger_custom_event",
        "cdktf_cdktf_provider_azurerm.data_factory_trigger_schedule",
        "cdktf_cdktf_provider_azurerm.data_factory_trigger_tumbling_window",
        "cdktf_cdktf_provider_azurerm.data_protection_backup_instance_blob_storage",
        "cdktf_cdktf_provider_azurerm.data_protection_backup_instance_disk",
        "cdktf_cdktf_provider_azurerm.data_protection_backup_instance_postgresql",
        "cdktf_cdktf_provider_azurerm.data_protection_backup_policy_blob_storage",
        "cdktf_cdktf_provider_azurerm.data_protection_backup_policy_disk",
        "cdktf_cdktf_provider_azurerm.data_protection_backup_policy_postgresql",
        "cdktf_cdktf_provider_azurerm.data_protection_backup_vault",
        "cdktf_cdktf_provider_azurerm.data_protection_resource_guard",
        "cdktf_cdktf_provider_azurerm.data_share",
        "cdktf_cdktf_provider_azurerm.data_share_account",
        "cdktf_cdktf_provider_azurerm.data_share_dataset_blob_storage",
        "cdktf_cdktf_provider_azurerm.data_share_dataset_data_lake_gen2",
        "cdktf_cdktf_provider_azurerm.data_share_dataset_kusto_cluster",
        "cdktf_cdktf_provider_azurerm.data_share_dataset_kusto_database",
        "cdktf_cdktf_provider_azurerm.database_migration_project",
        "cdktf_cdktf_provider_azurerm.database_migration_service",
        "cdktf_cdktf_provider_azurerm.databox_edge_device",
        "cdktf_cdktf_provider_azurerm.databox_edge_order",
        "cdktf_cdktf_provider_azurerm.databricks_access_connector",
        "cdktf_cdktf_provider_azurerm.databricks_virtual_network_peering",
        "cdktf_cdktf_provider_azurerm.databricks_workspace",
        "cdktf_cdktf_provider_azurerm.databricks_workspace_customer_managed_key",
        "cdktf_cdktf_provider_azurerm.databricks_workspace_root_dbfs_customer_managed_key",
        "cdktf_cdktf_provider_azurerm.datadog_monitor",
        "cdktf_cdktf_provider_azurerm.datadog_monitor_sso_configuration",
        "cdktf_cdktf_provider_azurerm.datadog_monitor_tag_rule",
        "cdktf_cdktf_provider_azurerm.dedicated_hardware_security_module",
        "cdktf_cdktf_provider_azurerm.dedicated_host",
        "cdktf_cdktf_provider_azurerm.dedicated_host_group",
        "cdktf_cdktf_provider_azurerm.dev_test_global_vm_shutdown_schedule",
        "cdktf_cdktf_provider_azurerm.dev_test_lab",
        "cdktf_cdktf_provider_azurerm.dev_test_linux_virtual_machine",
        "cdktf_cdktf_provider_azurerm.dev_test_policy",
        "cdktf_cdktf_provider_azurerm.dev_test_schedule",
        "cdktf_cdktf_provider_azurerm.dev_test_virtual_network",
        "cdktf_cdktf_provider_azurerm.dev_test_windows_virtual_machine",
        "cdktf_cdktf_provider_azurerm.digital_twins_endpoint_eventgrid",
        "cdktf_cdktf_provider_azurerm.digital_twins_endpoint_eventhub",
        "cdktf_cdktf_provider_azurerm.digital_twins_endpoint_servicebus",
        "cdktf_cdktf_provider_azurerm.digital_twins_instance",
        "cdktf_cdktf_provider_azurerm.digital_twins_time_series_database_connection",
        "cdktf_cdktf_provider_azurerm.disk_access",
        "cdktf_cdktf_provider_azurerm.disk_encryption_set",
        "cdktf_cdktf_provider_azurerm.disk_pool",
        "cdktf_cdktf_provider_azurerm.disk_pool_iscsi_target",
        "cdktf_cdktf_provider_azurerm.disk_pool_iscsi_target_lun",
        "cdktf_cdktf_provider_azurerm.disk_pool_managed_disk_attachment",
        "cdktf_cdktf_provider_azurerm.dns_a_record",
        "cdktf_cdktf_provider_azurerm.dns_aaaa_record",
        "cdktf_cdktf_provider_azurerm.dns_caa_record",
        "cdktf_cdktf_provider_azurerm.dns_cname_record",
        "cdktf_cdktf_provider_azurerm.dns_mx_record",
        "cdktf_cdktf_provider_azurerm.dns_ns_record",
        "cdktf_cdktf_provider_azurerm.dns_ptr_record",
        "cdktf_cdktf_provider_azurerm.dns_srv_record",
        "cdktf_cdktf_provider_azurerm.dns_txt_record",
        "cdktf_cdktf_provider_azurerm.dns_zone",
        "cdktf_cdktf_provider_azurerm.elastic_cloud_elasticsearch",
        "cdktf_cdktf_provider_azurerm.email_communication_service",
        "cdktf_cdktf_provider_azurerm.eventgrid_domain",
        "cdktf_cdktf_provider_azurerm.eventgrid_domain_topic",
        "cdktf_cdktf_provider_azurerm.eventgrid_event_subscription",
        "cdktf_cdktf_provider_azurerm.eventgrid_system_topic",
        "cdktf_cdktf_provider_azurerm.eventgrid_system_topic_event_subscription",
        "cdktf_cdktf_provider_azurerm.eventgrid_topic",
        "cdktf_cdktf_provider_azurerm.eventhub",
        "cdktf_cdktf_provider_azurerm.eventhub_authorization_rule",
        "cdktf_cdktf_provider_azurerm.eventhub_cluster",
        "cdktf_cdktf_provider_azurerm.eventhub_consumer_group",
        "cdktf_cdktf_provider_azurerm.eventhub_namespace",
        "cdktf_cdktf_provider_azurerm.eventhub_namespace_authorization_rule",
        "cdktf_cdktf_provider_azurerm.eventhub_namespace_customer_managed_key",
        "cdktf_cdktf_provider_azurerm.eventhub_namespace_disaster_recovery_config",
        "cdktf_cdktf_provider_azurerm.eventhub_namespace_schema_group",
        "cdktf_cdktf_provider_azurerm.express_route_circuit",
        "cdktf_cdktf_provider_azurerm.express_route_circuit_authorization",
        "cdktf_cdktf_provider_azurerm.express_route_circuit_connection",
        "cdktf_cdktf_provider_azurerm.express_route_circuit_peering",
        "cdktf_cdktf_provider_azurerm.express_route_connection",
        "cdktf_cdktf_provider_azurerm.express_route_gateway",
        "cdktf_cdktf_provider_azurerm.express_route_port",
        "cdktf_cdktf_provider_azurerm.express_route_port_authorization",
        "cdktf_cdktf_provider_azurerm.federated_identity_credential",
        "cdktf_cdktf_provider_azurerm.firewall",
        "cdktf_cdktf_provider_azurerm.firewall_application_rule_collection",
        "cdktf_cdktf_provider_azurerm.firewall_nat_rule_collection",
        "cdktf_cdktf_provider_azurerm.firewall_network_rule_collection",
        "cdktf_cdktf_provider_azurerm.firewall_policy",
        "cdktf_cdktf_provider_azurerm.firewall_policy_rule_collection_group",
        "cdktf_cdktf_provider_azurerm.fluid_relay_server",
        "cdktf_cdktf_provider_azurerm.frontdoor",
        "cdktf_cdktf_provider_azurerm.frontdoor_custom_https_configuration",
        "cdktf_cdktf_provider_azurerm.frontdoor_firewall_policy",
        "cdktf_cdktf_provider_azurerm.frontdoor_rules_engine",
        "cdktf_cdktf_provider_azurerm.function_app",
        "cdktf_cdktf_provider_azurerm.function_app_active_slot",
        "cdktf_cdktf_provider_azurerm.function_app_connection",
        "cdktf_cdktf_provider_azurerm.function_app_function",
        "cdktf_cdktf_provider_azurerm.function_app_hybrid_connection",
        "cdktf_cdktf_provider_azurerm.function_app_slot",
        "cdktf_cdktf_provider_azurerm.gallery_application",
        "cdktf_cdktf_provider_azurerm.gallery_application_version",
        "cdktf_cdktf_provider_azurerm.graph_account",
        "cdktf_cdktf_provider_azurerm.graph_services_account",
        "cdktf_cdktf_provider_azurerm.hdinsight_hadoop_cluster",
        "cdktf_cdktf_provider_azurerm.hdinsight_hbase_cluster",
        "cdktf_cdktf_provider_azurerm.hdinsight_interactive_query_cluster",
        "cdktf_cdktf_provider_azurerm.hdinsight_kafka_cluster",
        "cdktf_cdktf_provider_azurerm.hdinsight_spark_cluster",
        "cdktf_cdktf_provider_azurerm.healthbot",
        "cdktf_cdktf_provider_azurerm.healthcare_dicom_service",
        "cdktf_cdktf_provider_azurerm.healthcare_fhir_service",
        "cdktf_cdktf_provider_azurerm.healthcare_medtech_service",
        "cdktf_cdktf_provider_azurerm.healthcare_medtech_service_fhir_destination",
        "cdktf_cdktf_provider_azurerm.healthcare_service",
        "cdktf_cdktf_provider_azurerm.healthcare_workspace",
        "cdktf_cdktf_provider_azurerm.hpc_cache",
        "cdktf_cdktf_provider_azurerm.hpc_cache_access_policy",
        "cdktf_cdktf_provider_azurerm.hpc_cache_blob_nfs_target",
        "cdktf_cdktf_provider_azurerm.hpc_cache_blob_target",
        "cdktf_cdktf_provider_azurerm.hpc_cache_nfs_target",
        "cdktf_cdktf_provider_azurerm.image",
        "cdktf_cdktf_provider_azurerm.integration_service_environment",
        "cdktf_cdktf_provider_azurerm.iot_security_device_group",
        "cdktf_cdktf_provider_azurerm.iot_security_solution",
        "cdktf_cdktf_provider_azurerm.iot_time_series_insights_access_policy",
        "cdktf_cdktf_provider_azurerm.iot_time_series_insights_event_source_eventhub",
        "cdktf_cdktf_provider_azurerm.iot_time_series_insights_event_source_iothub",
        "cdktf_cdktf_provider_azurerm.iot_time_series_insights_gen2_environment",
        "cdktf_cdktf_provider_azurerm.iot_time_series_insights_reference_data_set",
        "cdktf_cdktf_provider_azurerm.iot_time_series_insights_standard_environment",
        "cdktf_cdktf_provider_azurerm.iotcentral_application",
        "cdktf_cdktf_provider_azurerm.iotcentral_application_network_rule_set",
        "cdktf_cdktf_provider_azurerm.iothub",
        "cdktf_cdktf_provider_azurerm.iothub_certificate",
        "cdktf_cdktf_provider_azurerm.iothub_consumer_group",
        "cdktf_cdktf_provider_azurerm.iothub_device_update_account",
        "cdktf_cdktf_provider_azurerm.iothub_device_update_instance",
        "cdktf_cdktf_provider_azurerm.iothub_dps",
        "cdktf_cdktf_provider_azurerm.iothub_dps_certificate",
        "cdktf_cdktf_provider_azurerm.iothub_dps_shared_access_policy",
        "cdktf_cdktf_provider_azurerm.iothub_endpoint_cosmosdb_account",
        "cdktf_cdktf_provider_azurerm.iothub_endpoint_eventhub",
        "cdktf_cdktf_provider_azurerm.iothub_endpoint_servicebus_queue",
        "cdktf_cdktf_provider_azurerm.iothub_endpoint_servicebus_topic",
        "cdktf_cdktf_provider_azurerm.iothub_endpoint_storage_container",
        "cdktf_cdktf_provider_azurerm.iothub_enrichment",
        "cdktf_cdktf_provider_azurerm.iothub_fallback_route",
        "cdktf_cdktf_provider_azurerm.iothub_file_upload",
        "cdktf_cdktf_provider_azurerm.iothub_route",
        "cdktf_cdktf_provider_azurerm.iothub_shared_access_policy",
        "cdktf_cdktf_provider_azurerm.ip_group",
        "cdktf_cdktf_provider_azurerm.ip_group_cidr",
        "cdktf_cdktf_provider_azurerm.key_vault",
        "cdktf_cdktf_provider_azurerm.key_vault_access_policy",
        "cdktf_cdktf_provider_azurerm.key_vault_certificate",
        "cdktf_cdktf_provider_azurerm.key_vault_certificate_contacts",
        "cdktf_cdktf_provider_azurerm.key_vault_certificate_issuer",
        "cdktf_cdktf_provider_azurerm.key_vault_key",
        "cdktf_cdktf_provider_azurerm.key_vault_managed_hardware_security_module",
        "cdktf_cdktf_provider_azurerm.key_vault_managed_storage_account",
        "cdktf_cdktf_provider_azurerm.key_vault_managed_storage_account_sas_token_definition",
        "cdktf_cdktf_provider_azurerm.key_vault_secret",
        "cdktf_cdktf_provider_azurerm.kubernetes_cluster",
        "cdktf_cdktf_provider_azurerm.kubernetes_cluster_extension",
        "cdktf_cdktf_provider_azurerm.kubernetes_cluster_node_pool",
        "cdktf_cdktf_provider_azurerm.kubernetes_cluster_trusted_access_role_binding",
        "cdktf_cdktf_provider_azurerm.kubernetes_fleet_manager",
        "cdktf_cdktf_provider_azurerm.kubernetes_flux_configuration",
        "cdktf_cdktf_provider_azurerm.kusto_attached_database_configuration",
        "cdktf_cdktf_provider_azurerm.kusto_cluster",
        "cdktf_cdktf_provider_azurerm.kusto_cluster_customer_managed_key",
        "cdktf_cdktf_provider_azurerm.kusto_cluster_managed_private_endpoint",
        "cdktf_cdktf_provider_azurerm.kusto_cluster_principal_assignment",
        "cdktf_cdktf_provider_azurerm.kusto_cosmosdb_data_connection",
        "cdktf_cdktf_provider_azurerm.kusto_database",
        "cdktf_cdktf_provider_azurerm.kusto_database_principal_assignment",
        "cdktf_cdktf_provider_azurerm.kusto_eventgrid_data_connection",
        "cdktf_cdktf_provider_azurerm.kusto_eventhub_data_connection",
        "cdktf_cdktf_provider_azurerm.kusto_iothub_data_connection",
        "cdktf_cdktf_provider_azurerm.kusto_script",
        "cdktf_cdktf_provider_azurerm.lab_service_lab",
        "cdktf_cdktf_provider_azurerm.lab_service_plan",
        "cdktf_cdktf_provider_azurerm.lab_service_schedule",
        "cdktf_cdktf_provider_azurerm.lab_service_user",
        "cdktf_cdktf_provider_azurerm.lb",
        "cdktf_cdktf_provider_azurerm.lb_backend_address_pool",
        "cdktf_cdktf_provider_azurerm.lb_backend_address_pool_address",
        "cdktf_cdktf_provider_azurerm.lb_nat_pool",
        "cdktf_cdktf_provider_azurerm.lb_nat_rule",
        "cdktf_cdktf_provider_azurerm.lb_outbound_rule",
        "cdktf_cdktf_provider_azurerm.lb_probe",
        "cdktf_cdktf_provider_azurerm.lb_rule",
        "cdktf_cdktf_provider_azurerm.lighthouse_assignment",
        "cdktf_cdktf_provider_azurerm.lighthouse_definition",
        "cdktf_cdktf_provider_azurerm.linux_function_app",
        "cdktf_cdktf_provider_azurerm.linux_function_app_slot",
        "cdktf_cdktf_provider_azurerm.linux_virtual_machine",
        "cdktf_cdktf_provider_azurerm.linux_virtual_machine_scale_set",
        "cdktf_cdktf_provider_azurerm.linux_web_app",
        "cdktf_cdktf_provider_azurerm.linux_web_app_slot",
        "cdktf_cdktf_provider_azurerm.load_test",
        "cdktf_cdktf_provider_azurerm.local_network_gateway",
        "cdktf_cdktf_provider_azurerm.log_analytics_cluster",
        "cdktf_cdktf_provider_azurerm.log_analytics_cluster_customer_managed_key",
        "cdktf_cdktf_provider_azurerm.log_analytics_data_export_rule",
        "cdktf_cdktf_provider_azurerm.log_analytics_datasource_windows_event",
        "cdktf_cdktf_provider_azurerm.log_analytics_datasource_windows_performance_counter",
        "cdktf_cdktf_provider_azurerm.log_analytics_linked_service",
        "cdktf_cdktf_provider_azurerm.log_analytics_linked_storage_account",
        "cdktf_cdktf_provider_azurerm.log_analytics_query_pack",
        "cdktf_cdktf_provider_azurerm.log_analytics_query_pack_query",
        "cdktf_cdktf_provider_azurerm.log_analytics_saved_search",
        "cdktf_cdktf_provider_azurerm.log_analytics_solution",
        "cdktf_cdktf_provider_azurerm.log_analytics_storage_insights",
        "cdktf_cdktf_provider_azurerm.log_analytics_workspace",
        "cdktf_cdktf_provider_azurerm.logic_app_action_custom",
        "cdktf_cdktf_provider_azurerm.logic_app_action_http",
        "cdktf_cdktf_provider_azurerm.logic_app_integration_account",
        "cdktf_cdktf_provider_azurerm.logic_app_integration_account_agreement",
        "cdktf_cdktf_provider_azurerm.logic_app_integration_account_assembly",
        "cdktf_cdktf_provider_azurerm.logic_app_integration_account_batch_configuration",
        "cdktf_cdktf_provider_azurerm.logic_app_integration_account_certificate",
        "cdktf_cdktf_provider_azurerm.logic_app_integration_account_map",
        "cdktf_cdktf_provider_azurerm.logic_app_integration_account_partner",
        "cdktf_cdktf_provider_azurerm.logic_app_integration_account_schema",
        "cdktf_cdktf_provider_azurerm.logic_app_integration_account_session",
        "cdktf_cdktf_provider_azurerm.logic_app_standard",
        "cdktf_cdktf_provider_azurerm.logic_app_trigger_custom",
        "cdktf_cdktf_provider_azurerm.logic_app_trigger_http_request",
        "cdktf_cdktf_provider_azurerm.logic_app_trigger_recurrence",
        "cdktf_cdktf_provider_azurerm.logic_app_workflow",
        "cdktf_cdktf_provider_azurerm.logz_monitor",
        "cdktf_cdktf_provider_azurerm.logz_sub_account",
        "cdktf_cdktf_provider_azurerm.logz_sub_account_tag_rule",
        "cdktf_cdktf_provider_azurerm.logz_tag_rule",
        "cdktf_cdktf_provider_azurerm.machine_learning_compute_cluster",
        "cdktf_cdktf_provider_azurerm.machine_learning_compute_instance",
        "cdktf_cdktf_provider_azurerm.machine_learning_datastore_blobstorage",
        "cdktf_cdktf_provider_azurerm.machine_learning_datastore_datalake_gen2",
        "cdktf_cdktf_provider_azurerm.machine_learning_datastore_fileshare",
        "cdktf_cdktf_provider_azurerm.machine_learning_inference_cluster",
        "cdktf_cdktf_provider_azurerm.machine_learning_synapse_spark",
        "cdktf_cdktf_provider_azurerm.machine_learning_workspace",
        "cdktf_cdktf_provider_azurerm.maintenance_assignment_dedicated_host",
        "cdktf_cdktf_provider_azurerm.maintenance_assignment_virtual_machine",
        "cdktf_cdktf_provider_azurerm.maintenance_assignment_virtual_machine_scale_set",
        "cdktf_cdktf_provider_azurerm.maintenance_configuration",
        "cdktf_cdktf_provider_azurerm.managed_application",
        "cdktf_cdktf_provider_azurerm.managed_application_definition",
        "cdktf_cdktf_provider_azurerm.managed_disk",
        "cdktf_cdktf_provider_azurerm.managed_disk_sas_token",
        "cdktf_cdktf_provider_azurerm.managed_lustre_file_system",
        "cdktf_cdktf_provider_azurerm.management_group",
        "cdktf_cdktf_provider_azurerm.management_group_policy_assignment",
        "cdktf_cdktf_provider_azurerm.management_group_policy_exemption",
        "cdktf_cdktf_provider_azurerm.management_group_policy_remediation",
        "cdktf_cdktf_provider_azurerm.management_group_subscription_association",
        "cdktf_cdktf_provider_azurerm.management_group_template_deployment",
        "cdktf_cdktf_provider_azurerm.management_lock",
        "cdktf_cdktf_provider_azurerm.maps_account",
        "cdktf_cdktf_provider_azurerm.maps_creator",
        "cdktf_cdktf_provider_azurerm.mariadb_configuration",
        "cdktf_cdktf_provider_azurerm.mariadb_database",
        "cdktf_cdktf_provider_azurerm.mariadb_firewall_rule",
        "cdktf_cdktf_provider_azurerm.mariadb_server",
        "cdktf_cdktf_provider_azurerm.mariadb_virtual_network_rule",
        "cdktf_cdktf_provider_azurerm.marketplace_agreement",
        "cdktf_cdktf_provider_azurerm.marketplace_role_assignment",
        "cdktf_cdktf_provider_azurerm.media_asset",
        "cdktf_cdktf_provider_azurerm.media_asset_filter",
        "cdktf_cdktf_provider_azurerm.media_content_key_policy",
        "cdktf_cdktf_provider_azurerm.media_job",
        "cdktf_cdktf_provider_azurerm.media_live_event",
        "cdktf_cdktf_provider_azurerm.media_live_event_output",
        "cdktf_cdktf_provider_azurerm.media_services_account",
        "cdktf_cdktf_provider_azurerm.media_services_account_filter",
        "cdktf_cdktf_provider_azurerm.media_streaming_endpoint",
        "cdktf_cdktf_provider_azurerm.media_streaming_locator",
        "cdktf_cdktf_provider_azurerm.media_streaming_policy",
        "cdktf_cdktf_provider_azurerm.media_transform",
        "cdktf_cdktf_provider_azurerm.mobile_network",
        "cdktf_cdktf_provider_azurerm.mobile_network_attached_data_network",
        "cdktf_cdktf_provider_azurerm.mobile_network_data_network",
        "cdktf_cdktf_provider_azurerm.mobile_network_packet_core_control_plane",
        "cdktf_cdktf_provider_azurerm.mobile_network_packet_core_data_plane",
        "cdktf_cdktf_provider_azurerm.mobile_network_service",
        "cdktf_cdktf_provider_azurerm.mobile_network_sim",
        "cdktf_cdktf_provider_azurerm.mobile_network_sim_group",
        "cdktf_cdktf_provider_azurerm.mobile_network_sim_policy",
        "cdktf_cdktf_provider_azurerm.mobile_network_site",
        "cdktf_cdktf_provider_azurerm.mobile_network_slice",
        "cdktf_cdktf_provider_azurerm.monitor_aad_diagnostic_setting",
        "cdktf_cdktf_provider_azurerm.monitor_action_group",
        "cdktf_cdktf_provider_azurerm.monitor_action_rule_action_group",
        "cdktf_cdktf_provider_azurerm.monitor_action_rule_suppression",
        "cdktf_cdktf_provider_azurerm.monitor_activity_log_alert",
        "cdktf_cdktf_provider_azurerm.monitor_alert_processing_rule_action_group",
        "cdktf_cdktf_provider_azurerm.monitor_alert_processing_rule_suppression",
        "cdktf_cdktf_provider_azurerm.monitor_alert_prometheus_rule_group",
        "cdktf_cdktf_provider_azurerm.monitor_autoscale_setting",
        "cdktf_cdktf_provider_azurerm.monitor_data_collection_endpoint",
        "cdktf_cdktf_provider_azurerm.monitor_data_collection_rule",
        "cdktf_cdktf_provider_azurerm.monitor_data_collection_rule_association",
        "cdktf_cdktf_provider_azurerm.monitor_diagnostic_setting",
        "cdktf_cdktf_provider_azurerm.monitor_log_profile",
        "cdktf_cdktf_provider_azurerm.monitor_metric_alert",
        "cdktf_cdktf_provider_azurerm.monitor_private_link_scope",
        "cdktf_cdktf_provider_azurerm.monitor_private_link_scoped_service",
        "cdktf_cdktf_provider_azurerm.monitor_scheduled_query_rules_alert",
        "cdktf_cdktf_provider_azurerm.monitor_scheduled_query_rules_alert_v2",
        "cdktf_cdktf_provider_azurerm.monitor_scheduled_query_rules_log",
        "cdktf_cdktf_provider_azurerm.monitor_smart_detector_alert_rule",
        "cdktf_cdktf_provider_azurerm.monitor_workspace",
        "cdktf_cdktf_provider_azurerm.mssql_database",
        "cdktf_cdktf_provider_azurerm.mssql_database_extended_auditing_policy",
        "cdktf_cdktf_provider_azurerm.mssql_database_vulnerability_assessment_rule_baseline",
        "cdktf_cdktf_provider_azurerm.mssql_elasticpool",
        "cdktf_cdktf_provider_azurerm.mssql_failover_group",
        "cdktf_cdktf_provider_azurerm.mssql_firewall_rule",
        "cdktf_cdktf_provider_azurerm.mssql_job_agent",
        "cdktf_cdktf_provider_azurerm.mssql_job_credential",
        "cdktf_cdktf_provider_azurerm.mssql_managed_database",
        "cdktf_cdktf_provider_azurerm.mssql_managed_instance",
        "cdktf_cdktf_provider_azurerm.mssql_managed_instance_active_directory_administrator",
        "cdktf_cdktf_provider_azurerm.mssql_managed_instance_failover_group",
        "cdktf_cdktf_provider_azurerm.mssql_managed_instance_security_alert_policy",
        "cdktf_cdktf_provider_azurerm.mssql_managed_instance_transparent_data_encryption",
        "cdktf_cdktf_provider_azurerm.mssql_managed_instance_vulnerability_assessment",
        "cdktf_cdktf_provider_azurerm.mssql_outbound_firewall_rule",
        "cdktf_cdktf_provider_azurerm.mssql_server",
        "cdktf_cdktf_provider_azurerm.mssql_server_dns_alias",
        "cdktf_cdktf_provider_azurerm.mssql_server_extended_auditing_policy",
        "cdktf_cdktf_provider_azurerm.mssql_server_microsoft_support_auditing_policy",
        "cdktf_cdktf_provider_azurerm.mssql_server_security_alert_policy",
        "cdktf_cdktf_provider_azurerm.mssql_server_transparent_data_encryption",
        "cdktf_cdktf_provider_azurerm.mssql_server_vulnerability_assessment",
        "cdktf_cdktf_provider_azurerm.mssql_virtual_machine",
        "cdktf_cdktf_provider_azurerm.mssql_virtual_machine_availability_group_listener",
        "cdktf_cdktf_provider_azurerm.mssql_virtual_machine_group",
        "cdktf_cdktf_provider_azurerm.mssql_virtual_network_rule",
        "cdktf_cdktf_provider_azurerm.mysql_active_directory_administrator",
        "cdktf_cdktf_provider_azurerm.mysql_configuration",
        "cdktf_cdktf_provider_azurerm.mysql_database",
        "cdktf_cdktf_provider_azurerm.mysql_firewall_rule",
        "cdktf_cdktf_provider_azurerm.mysql_flexible_database",
        "cdktf_cdktf_provider_azurerm.mysql_flexible_server",
        "cdktf_cdktf_provider_azurerm.mysql_flexible_server_active_directory_administrator",
        "cdktf_cdktf_provider_azurerm.mysql_flexible_server_configuration",
        "cdktf_cdktf_provider_azurerm.mysql_flexible_server_firewall_rule",
        "cdktf_cdktf_provider_azurerm.mysql_server",
        "cdktf_cdktf_provider_azurerm.mysql_server_key",
        "cdktf_cdktf_provider_azurerm.mysql_virtual_network_rule",
        "cdktf_cdktf_provider_azurerm.nat_gateway",
        "cdktf_cdktf_provider_azurerm.nat_gateway_public_ip_association",
        "cdktf_cdktf_provider_azurerm.nat_gateway_public_ip_prefix_association",
        "cdktf_cdktf_provider_azurerm.netapp_account",
        "cdktf_cdktf_provider_azurerm.netapp_pool",
        "cdktf_cdktf_provider_azurerm.netapp_snapshot",
        "cdktf_cdktf_provider_azurerm.netapp_snapshot_policy",
        "cdktf_cdktf_provider_azurerm.netapp_volume",
        "cdktf_cdktf_provider_azurerm.netapp_volume_group_sap_hana",
        "cdktf_cdktf_provider_azurerm.netapp_volume_quota_rule",
        "cdktf_cdktf_provider_azurerm.network_connection_monitor",
        "cdktf_cdktf_provider_azurerm.network_ddos_protection_plan",
        "cdktf_cdktf_provider_azurerm.network_function_azure_traffic_collector",
        "cdktf_cdktf_provider_azurerm.network_interface",
        "cdktf_cdktf_provider_azurerm.network_interface_application_gateway_backend_address_pool_association",
        "cdktf_cdktf_provider_azurerm.network_interface_application_security_group_association",
        "cdktf_cdktf_provider_azurerm.network_interface_backend_address_pool_association",
        "cdktf_cdktf_provider_azurerm.network_interface_nat_rule_association",
        "cdktf_cdktf_provider_azurerm.network_interface_security_group_association",
        "cdktf_cdktf_provider_azurerm.network_manager",
        "cdktf_cdktf_provider_azurerm.network_manager_admin_rule",
        "cdktf_cdktf_provider_azurerm.network_manager_admin_rule_collection",
        "cdktf_cdktf_provider_azurerm.network_manager_connectivity_configuration",
        "cdktf_cdktf_provider_azurerm.network_manager_deployment",
        "cdktf_cdktf_provider_azurerm.network_manager_management_group_connection",
        "cdktf_cdktf_provider_azurerm.network_manager_network_group",
        "cdktf_cdktf_provider_azurerm.network_manager_scope_connection",
        "cdktf_cdktf_provider_azurerm.network_manager_security_admin_configuration",
        "cdktf_cdktf_provider_azurerm.network_manager_static_member",
        "cdktf_cdktf_provider_azurerm.network_manager_subscription_connection",
        "cdktf_cdktf_provider_azurerm.network_packet_capture",
        "cdktf_cdktf_provider_azurerm.network_profile",
        "cdktf_cdktf_provider_azurerm.network_security_group",
        "cdktf_cdktf_provider_azurerm.network_security_rule",
        "cdktf_cdktf_provider_azurerm.network_watcher",
        "cdktf_cdktf_provider_azurerm.network_watcher_flow_log",
        "cdktf_cdktf_provider_azurerm.new_relic_monitor",
        "cdktf_cdktf_provider_azurerm.new_relic_tag_rule",
        "cdktf_cdktf_provider_azurerm.nginx_certificate",
        "cdktf_cdktf_provider_azurerm.nginx_configuration",
        "cdktf_cdktf_provider_azurerm.nginx_deployment",
        "cdktf_cdktf_provider_azurerm.notification_hub",
        "cdktf_cdktf_provider_azurerm.notification_hub_authorization_rule",
        "cdktf_cdktf_provider_azurerm.notification_hub_namespace",
        "cdktf_cdktf_provider_azurerm.orbital_contact",
        "cdktf_cdktf_provider_azurerm.orbital_contact_profile",
        "cdktf_cdktf_provider_azurerm.orbital_spacecraft",
        "cdktf_cdktf_provider_azurerm.orchestrated_virtual_machine_scale_set",
        "cdktf_cdktf_provider_azurerm.palo_alto_local_rulestack",
        "cdktf_cdktf_provider_azurerm.palo_alto_local_rulestack_certificate",
        "cdktf_cdktf_provider_azurerm.palo_alto_local_rulestack_fqdn_list",
        "cdktf_cdktf_provider_azurerm.palo_alto_local_rulestack_outbound_trust_certificate_association",
        "cdktf_cdktf_provider_azurerm.palo_alto_local_rulestack_outbound_untrust_certificate_association",
        "cdktf_cdktf_provider_azurerm.palo_alto_local_rulestack_prefix_list",
        "cdktf_cdktf_provider_azurerm.palo_alto_local_rulestack_rule",
        "cdktf_cdktf_provider_azurerm.palo_alto_next_generation_firewall_virtual_hub_local_rulestack",
        "cdktf_cdktf_provider_azurerm.palo_alto_next_generation_firewall_virtual_hub_panorama",
        "cdktf_cdktf_provider_azurerm.palo_alto_next_generation_firewall_virtual_network_local_rulestack",
        "cdktf_cdktf_provider_azurerm.palo_alto_next_generation_firewall_virtual_network_panorama",
        "cdktf_cdktf_provider_azurerm.palo_alto_virtual_network_appliance",
        "cdktf_cdktf_provider_azurerm.pim_active_role_assignment",
        "cdktf_cdktf_provider_azurerm.pim_eligible_role_assignment",
        "cdktf_cdktf_provider_azurerm.point_to_site_vpn_gateway",
        "cdktf_cdktf_provider_azurerm.policy_definition",
        "cdktf_cdktf_provider_azurerm.policy_set_definition",
        "cdktf_cdktf_provider_azurerm.policy_virtual_machine_configuration_assignment",
        "cdktf_cdktf_provider_azurerm.portal_dashboard",
        "cdktf_cdktf_provider_azurerm.portal_tenant_configuration",
        "cdktf_cdktf_provider_azurerm.postgresql_active_directory_administrator",
        "cdktf_cdktf_provider_azurerm.postgresql_configuration",
        "cdktf_cdktf_provider_azurerm.postgresql_database",
        "cdktf_cdktf_provider_azurerm.postgresql_firewall_rule",
        "cdktf_cdktf_provider_azurerm.postgresql_flexible_server",
        "cdktf_cdktf_provider_azurerm.postgresql_flexible_server_active_directory_administrator",
        "cdktf_cdktf_provider_azurerm.postgresql_flexible_server_configuration",
        "cdktf_cdktf_provider_azurerm.postgresql_flexible_server_database",
        "cdktf_cdktf_provider_azurerm.postgresql_flexible_server_firewall_rule",
        "cdktf_cdktf_provider_azurerm.postgresql_server",
        "cdktf_cdktf_provider_azurerm.postgresql_server_key",
        "cdktf_cdktf_provider_azurerm.postgresql_virtual_network_rule",
        "cdktf_cdktf_provider_azurerm.powerbi_embedded",
        "cdktf_cdktf_provider_azurerm.private_dns_a_record",
        "cdktf_cdktf_provider_azurerm.private_dns_aaaa_record",
        "cdktf_cdktf_provider_azurerm.private_dns_cname_record",
        "cdktf_cdktf_provider_azurerm.private_dns_mx_record",
        "cdktf_cdktf_provider_azurerm.private_dns_ptr_record",
        "cdktf_cdktf_provider_azurerm.private_dns_resolver",
        "cdktf_cdktf_provider_azurerm.private_dns_resolver_dns_forwarding_ruleset",
        "cdktf_cdktf_provider_azurerm.private_dns_resolver_forwarding_rule",
        "cdktf_cdktf_provider_azurerm.private_dns_resolver_inbound_endpoint",
        "cdktf_cdktf_provider_azurerm.private_dns_resolver_outbound_endpoint",
        "cdktf_cdktf_provider_azurerm.private_dns_resolver_virtual_network_link",
        "cdktf_cdktf_provider_azurerm.private_dns_srv_record",
        "cdktf_cdktf_provider_azurerm.private_dns_txt_record",
        "cdktf_cdktf_provider_azurerm.private_dns_zone",
        "cdktf_cdktf_provider_azurerm.private_dns_zone_virtual_network_link",
        "cdktf_cdktf_provider_azurerm.private_endpoint",
        "cdktf_cdktf_provider_azurerm.private_endpoint_application_security_group_association",
        "cdktf_cdktf_provider_azurerm.private_link_service",
        "cdktf_cdktf_provider_azurerm.provider",
        "cdktf_cdktf_provider_azurerm.proximity_placement_group",
        "cdktf_cdktf_provider_azurerm.public_ip",
        "cdktf_cdktf_provider_azurerm.public_ip_prefix",
        "cdktf_cdktf_provider_azurerm.purview_account",
        "cdktf_cdktf_provider_azurerm.recovery_services_vault",
        "cdktf_cdktf_provider_azurerm.recovery_services_vault_resource_guard_association",
        "cdktf_cdktf_provider_azurerm.redis_cache",
        "cdktf_cdktf_provider_azurerm.redis_enterprise_cluster",
        "cdktf_cdktf_provider_azurerm.redis_enterprise_database",
        "cdktf_cdktf_provider_azurerm.redis_firewall_rule",
        "cdktf_cdktf_provider_azurerm.redis_linked_server",
        "cdktf_cdktf_provider_azurerm.relay_hybrid_connection",
        "cdktf_cdktf_provider_azurerm.relay_hybrid_connection_authorization_rule",
        "cdktf_cdktf_provider_azurerm.relay_namespace",
        "cdktf_cdktf_provider_azurerm.relay_namespace_authorization_rule",
        "cdktf_cdktf_provider_azurerm.resource_deployment_script_azure_cli",
        "cdktf_cdktf_provider_azurerm.resource_deployment_script_azure_power_shell",
        "cdktf_cdktf_provider_azurerm.resource_group",
        "cdktf_cdktf_provider_azurerm.resource_group_cost_management_export",
        "cdktf_cdktf_provider_azurerm.resource_group_cost_management_view",
        "cdktf_cdktf_provider_azurerm.resource_group_policy_assignment",
        "cdktf_cdktf_provider_azurerm.resource_group_policy_exemption",
        "cdktf_cdktf_provider_azurerm.resource_group_policy_remediation",
        "cdktf_cdktf_provider_azurerm.resource_group_template_deployment",
        "cdktf_cdktf_provider_azurerm.resource_management_private_link",
        "cdktf_cdktf_provider_azurerm.resource_policy_assignment",
        "cdktf_cdktf_provider_azurerm.resource_policy_exemption",
        "cdktf_cdktf_provider_azurerm.resource_policy_remediation",
        "cdktf_cdktf_provider_azurerm.resource_provider_registration",
        "cdktf_cdktf_provider_azurerm.role_assignment",
        "cdktf_cdktf_provider_azurerm.role_definition",
        "cdktf_cdktf_provider_azurerm.route",
        "cdktf_cdktf_provider_azurerm.route_filter",
        "cdktf_cdktf_provider_azurerm.route_map",
        "cdktf_cdktf_provider_azurerm.route_server",
        "cdktf_cdktf_provider_azurerm.route_server_bgp_connection",
        "cdktf_cdktf_provider_azurerm.route_table",
        "cdktf_cdktf_provider_azurerm.search_service",
        "cdktf_cdktf_provider_azurerm.search_shared_private_link_service",
        "cdktf_cdktf_provider_azurerm.security_center_assessment",
        "cdktf_cdktf_provider_azurerm.security_center_assessment_policy",
        "cdktf_cdktf_provider_azurerm.security_center_auto_provisioning",
        "cdktf_cdktf_provider_azurerm.security_center_automation",
        "cdktf_cdktf_provider_azurerm.security_center_contact",
        "cdktf_cdktf_provider_azurerm.security_center_server_vulnerability_assessment",
        "cdktf_cdktf_provider_azurerm.security_center_server_vulnerability_assessment_virtual_machine",
        "cdktf_cdktf_provider_azurerm.security_center_setting",
        "cdktf_cdktf_provider_azurerm.security_center_storage_defender",
        "cdktf_cdktf_provider_azurerm.security_center_subscription_pricing",
        "cdktf_cdktf_provider_azurerm.security_center_workspace",
        "cdktf_cdktf_provider_azurerm.sentinel_alert_rule_anomaly_built_in",
        "cdktf_cdktf_provider_azurerm.sentinel_alert_rule_anomaly_duplicate",
        "cdktf_cdktf_provider_azurerm.sentinel_alert_rule_fusion",
        "cdktf_cdktf_provider_azurerm.sentinel_alert_rule_machine_learning_behavior_analytics",
        "cdktf_cdktf_provider_azurerm.sentinel_alert_rule_ms_security_incident",
        "cdktf_cdktf_provider_azurerm.sentinel_alert_rule_nrt",
        "cdktf_cdktf_provider_azurerm.sentinel_alert_rule_scheduled",
        "cdktf_cdktf_provider_azurerm.sentinel_alert_rule_threat_intelligence",
        "cdktf_cdktf_provider_azurerm.sentinel_automation_rule",
        "cdktf_cdktf_provider_azurerm.sentinel_data_connector_aws_cloud_trail",
        "cdktf_cdktf_provider_azurerm.sentinel_data_connector_aws_s3",
        "cdktf_cdktf_provider_azurerm.sentinel_data_connector_azure_active_directory",
        "cdktf_cdktf_provider_azurerm.sentinel_data_connector_azure_advanced_threat_protection",
        "cdktf_cdktf_provider_azurerm.sentinel_data_connector_azure_security_center",
        "cdktf_cdktf_provider_azurerm.sentinel_data_connector_dynamics365",
        "cdktf_cdktf_provider_azurerm.sentinel_data_connector_iot",
        "cdktf_cdktf_provider_azurerm.sentinel_data_connector_microsoft_cloud_app_security",
        "cdktf_cdktf_provider_azurerm.sentinel_data_connector_microsoft_defender_advanced_threat_protection",
        "cdktf_cdktf_provider_azurerm.sentinel_data_connector_microsoft_threat_intelligence",
        "cdktf_cdktf_provider_azurerm.sentinel_data_connector_microsoft_threat_protection",
        "cdktf_cdktf_provider_azurerm.sentinel_data_connector_office_atp",
        "cdktf_cdktf_provider_azurerm.sentinel_data_connector_office_irm",
        "cdktf_cdktf_provider_azurerm.sentinel_data_connector_office_power_bi",
        "cdktf_cdktf_provider_azurerm.sentinel_data_connector_office365",
        "cdktf_cdktf_provider_azurerm.sentinel_data_connector_office365_project",
        "cdktf_cdktf_provider_azurerm.sentinel_data_connector_threat_intelligence",
        "cdktf_cdktf_provider_azurerm.sentinel_data_connector_threat_intelligence_taxii",
        "cdktf_cdktf_provider_azurerm.sentinel_log_analytics_workspace_onboarding",
        "cdktf_cdktf_provider_azurerm.sentinel_metadata",
        "cdktf_cdktf_provider_azurerm.sentinel_threat_intelligence_indicator",
        "cdktf_cdktf_provider_azurerm.sentinel_watchlist",
        "cdktf_cdktf_provider_azurerm.sentinel_watchlist_item",
        "cdktf_cdktf_provider_azurerm.service_fabric_cluster",
        "cdktf_cdktf_provider_azurerm.service_fabric_managed_cluster",
        "cdktf_cdktf_provider_azurerm.service_plan",
        "cdktf_cdktf_provider_azurerm.servicebus_namespace",
        "cdktf_cdktf_provider_azurerm.servicebus_namespace_authorization_rule",
        "cdktf_cdktf_provider_azurerm.servicebus_namespace_disaster_recovery_config",
        "cdktf_cdktf_provider_azurerm.servicebus_namespace_network_rule_set",
        "cdktf_cdktf_provider_azurerm.servicebus_queue",
        "cdktf_cdktf_provider_azurerm.servicebus_queue_authorization_rule",
        "cdktf_cdktf_provider_azurerm.servicebus_subscription",
        "cdktf_cdktf_provider_azurerm.servicebus_subscription_rule",
        "cdktf_cdktf_provider_azurerm.servicebus_topic",
        "cdktf_cdktf_provider_azurerm.servicebus_topic_authorization_rule",
        "cdktf_cdktf_provider_azurerm.shared_image",
        "cdktf_cdktf_provider_azurerm.shared_image_gallery",
        "cdktf_cdktf_provider_azurerm.shared_image_version",
        "cdktf_cdktf_provider_azurerm.signalr_service",
        "cdktf_cdktf_provider_azurerm.signalr_service_custom_certificate",
        "cdktf_cdktf_provider_azurerm.signalr_service_custom_domain",
        "cdktf_cdktf_provider_azurerm.signalr_service_network_acl",
        "cdktf_cdktf_provider_azurerm.signalr_shared_private_link_resource",
        "cdktf_cdktf_provider_azurerm.site_recovery_fabric",
        "cdktf_cdktf_provider_azurerm.site_recovery_hyperv_network_mapping",
        "cdktf_cdktf_provider_azurerm.site_recovery_hyperv_replication_policy",
        "cdktf_cdktf_provider_azurerm.site_recovery_hyperv_replication_policy_association",
        "cdktf_cdktf_provider_azurerm.site_recovery_network_mapping",
        "cdktf_cdktf_provider_azurerm.site_recovery_protection_container",
        "cdktf_cdktf_provider_azurerm.site_recovery_protection_container_mapping",
        "cdktf_cdktf_provider_azurerm.site_recovery_replicated_vm",
        "cdktf_cdktf_provider_azurerm.site_recovery_replication_policy",
        "cdktf_cdktf_provider_azurerm.site_recovery_replication_recovery_plan",
        "cdktf_cdktf_provider_azurerm.site_recovery_services_vault_hyperv_site",
        "cdktf_cdktf_provider_azurerm.site_recovery_vmware_replication_policy",
        "cdktf_cdktf_provider_azurerm.site_recovery_vmware_replication_policy_association",
        "cdktf_cdktf_provider_azurerm.snapshot",
        "cdktf_cdktf_provider_azurerm.source_control_token",
        "cdktf_cdktf_provider_azurerm.spatial_anchors_account",
        "cdktf_cdktf_provider_azurerm.spring_cloud_accelerator",
        "cdktf_cdktf_provider_azurerm.spring_cloud_active_deployment",
        "cdktf_cdktf_provider_azurerm.spring_cloud_api_portal",
        "cdktf_cdktf_provider_azurerm.spring_cloud_api_portal_custom_domain",
        "cdktf_cdktf_provider_azurerm.spring_cloud_app",
        "cdktf_cdktf_provider_azurerm.spring_cloud_app_cosmosdb_association",
        "cdktf_cdktf_provider_azurerm.spring_cloud_app_mysql_association",
        "cdktf_cdktf_provider_azurerm.spring_cloud_app_redis_association",
        "cdktf_cdktf_provider_azurerm.spring_cloud_application_insights_application_performance_monitoring",
        "cdktf_cdktf_provider_azurerm.spring_cloud_application_live_view",
        "cdktf_cdktf_provider_azurerm.spring_cloud_build_deployment",
        "cdktf_cdktf_provider_azurerm.spring_cloud_build_pack_binding",
        "cdktf_cdktf_provider_azurerm.spring_cloud_builder",
        "cdktf_cdktf_provider_azurerm.spring_cloud_certificate",
        "cdktf_cdktf_provider_azurerm.spring_cloud_configuration_service",
        "cdktf_cdktf_provider_azurerm.spring_cloud_connection",
        "cdktf_cdktf_provider_azurerm.spring_cloud_container_deployment",
        "cdktf_cdktf_provider_azurerm.spring_cloud_custom_domain",
        "cdktf_cdktf_provider_azurerm.spring_cloud_customized_accelerator",
        "cdktf_cdktf_provider_azurerm.spring_cloud_dev_tool_portal",
        "cdktf_cdktf_provider_azurerm.spring_cloud_gateway",
        "cdktf_cdktf_provider_azurerm.spring_cloud_gateway_custom_domain",
        "cdktf_cdktf_provider_azurerm.spring_cloud_gateway_route_config",
        "cdktf_cdktf_provider_azurerm.spring_cloud_java_deployment",
        "cdktf_cdktf_provider_azurerm.spring_cloud_service",
        "cdktf_cdktf_provider_azurerm.spring_cloud_storage",
        "cdktf_cdktf_provider_azurerm.sql_active_directory_administrator",
        "cdktf_cdktf_provider_azurerm.sql_database",
        "cdktf_cdktf_provider_azurerm.sql_elasticpool",
        "cdktf_cdktf_provider_azurerm.sql_failover_group",
        "cdktf_cdktf_provider_azurerm.sql_firewall_rule",
        "cdktf_cdktf_provider_azurerm.sql_managed_database",
        "cdktf_cdktf_provider_azurerm.sql_managed_instance",
        "cdktf_cdktf_provider_azurerm.sql_managed_instance_active_directory_administrator",
        "cdktf_cdktf_provider_azurerm.sql_managed_instance_failover_group",
        "cdktf_cdktf_provider_azurerm.sql_server",
        "cdktf_cdktf_provider_azurerm.sql_virtual_network_rule",
        "cdktf_cdktf_provider_azurerm.ssh_public_key",
        "cdktf_cdktf_provider_azurerm.stack_hci_cluster",
        "cdktf_cdktf_provider_azurerm.static_site",
        "cdktf_cdktf_provider_azurerm.static_site_custom_domain",
        "cdktf_cdktf_provider_azurerm.storage_account",
        "cdktf_cdktf_provider_azurerm.storage_account_customer_managed_key",
        "cdktf_cdktf_provider_azurerm.storage_account_local_user",
        "cdktf_cdktf_provider_azurerm.storage_account_network_rules",
        "cdktf_cdktf_provider_azurerm.storage_blob",
        "cdktf_cdktf_provider_azurerm.storage_blob_inventory_policy",
        "cdktf_cdktf_provider_azurerm.storage_container",
        "cdktf_cdktf_provider_azurerm.storage_data_lake_gen2_filesystem",
        "cdktf_cdktf_provider_azurerm.storage_data_lake_gen2_path",
        "cdktf_cdktf_provider_azurerm.storage_encryption_scope",
        "cdktf_cdktf_provider_azurerm.storage_management_policy",
        "cdktf_cdktf_provider_azurerm.storage_mover",
        "cdktf_cdktf_provider_azurerm.storage_mover_agent",
        "cdktf_cdktf_provider_azurerm.storage_mover_job_definition",
        "cdktf_cdktf_provider_azurerm.storage_mover_project",
        "cdktf_cdktf_provider_azurerm.storage_mover_source_endpoint",
        "cdktf_cdktf_provider_azurerm.storage_mover_target_endpoint",
        "cdktf_cdktf_provider_azurerm.storage_object_replication",
        "cdktf_cdktf_provider_azurerm.storage_queue",
        "cdktf_cdktf_provider_azurerm.storage_share",
        "cdktf_cdktf_provider_azurerm.storage_share_directory",
        "cdktf_cdktf_provider_azurerm.storage_share_file",
        "cdktf_cdktf_provider_azurerm.storage_sync",
        "cdktf_cdktf_provider_azurerm.storage_sync_cloud_endpoint",
        "cdktf_cdktf_provider_azurerm.storage_sync_group",
        "cdktf_cdktf_provider_azurerm.storage_table",
        "cdktf_cdktf_provider_azurerm.storage_table_entity",
        "cdktf_cdktf_provider_azurerm.stream_analytics_cluster",
        "cdktf_cdktf_provider_azurerm.stream_analytics_function_javascript_uda",
        "cdktf_cdktf_provider_azurerm.stream_analytics_function_javascript_udf",
        "cdktf_cdktf_provider_azurerm.stream_analytics_job",
        "cdktf_cdktf_provider_azurerm.stream_analytics_job_schedule",
        "cdktf_cdktf_provider_azurerm.stream_analytics_managed_private_endpoint",
        "cdktf_cdktf_provider_azurerm.stream_analytics_output_blob",
        "cdktf_cdktf_provider_azurerm.stream_analytics_output_cosmosdb",
        "cdktf_cdktf_provider_azurerm.stream_analytics_output_eventhub",
        "cdktf_cdktf_provider_azurerm.stream_analytics_output_function",
        "cdktf_cdktf_provider_azurerm.stream_analytics_output_mssql",
        "cdktf_cdktf_provider_azurerm.stream_analytics_output_powerbi",
        "cdktf_cdktf_provider_azurerm.stream_analytics_output_servicebus_queue",
        "cdktf_cdktf_provider_azurerm.stream_analytics_output_servicebus_topic",
        "cdktf_cdktf_provider_azurerm.stream_analytics_output_synapse",
        "cdktf_cdktf_provider_azurerm.stream_analytics_output_table",
        "cdktf_cdktf_provider_azurerm.stream_analytics_reference_input_blob",
        "cdktf_cdktf_provider_azurerm.stream_analytics_reference_input_mssql",
        "cdktf_cdktf_provider_azurerm.stream_analytics_stream_input_blob",
        "cdktf_cdktf_provider_azurerm.stream_analytics_stream_input_eventhub",
        "cdktf_cdktf_provider_azurerm.stream_analytics_stream_input_eventhub_v2",
        "cdktf_cdktf_provider_azurerm.stream_analytics_stream_input_iothub",
        "cdktf_cdktf_provider_azurerm.subnet",
        "cdktf_cdktf_provider_azurerm.subnet_nat_gateway_association",
        "cdktf_cdktf_provider_azurerm.subnet_network_security_group_association",
        "cdktf_cdktf_provider_azurerm.subnet_route_table_association",
        "cdktf_cdktf_provider_azurerm.subnet_service_endpoint_storage_policy",
        "cdktf_cdktf_provider_azurerm.subscription",
        "cdktf_cdktf_provider_azurerm.subscription_cost_management_export",
        "cdktf_cdktf_provider_azurerm.subscription_cost_management_view",
        "cdktf_cdktf_provider_azurerm.subscription_policy_assignment",
        "cdktf_cdktf_provider_azurerm.subscription_policy_exemption",
        "cdktf_cdktf_provider_azurerm.subscription_policy_remediation",
        "cdktf_cdktf_provider_azurerm.subscription_template_deployment",
        "cdktf_cdktf_provider_azurerm.synapse_firewall_rule",
        "cdktf_cdktf_provider_azurerm.synapse_integration_runtime_azure",
        "cdktf_cdktf_provider_azurerm.synapse_integration_runtime_self_hosted",
        "cdktf_cdktf_provider_azurerm.synapse_linked_service",
        "cdktf_cdktf_provider_azurerm.synapse_managed_private_endpoint",
        "cdktf_cdktf_provider_azurerm.synapse_private_link_hub",
        "cdktf_cdktf_provider_azurerm.synapse_role_assignment",
        "cdktf_cdktf_provider_azurerm.synapse_spark_pool",
        "cdktf_cdktf_provider_azurerm.synapse_sql_pool",
        "cdktf_cdktf_provider_azurerm.synapse_sql_pool_extended_auditing_policy",
        "cdktf_cdktf_provider_azurerm.synapse_sql_pool_security_alert_policy",
        "cdktf_cdktf_provider_azurerm.synapse_sql_pool_vulnerability_assessment",
        "cdktf_cdktf_provider_azurerm.synapse_sql_pool_vulnerability_assessment_baseline",
        "cdktf_cdktf_provider_azurerm.synapse_sql_pool_workload_classifier",
        "cdktf_cdktf_provider_azurerm.synapse_sql_pool_workload_group",
        "cdktf_cdktf_provider_azurerm.synapse_workspace",
        "cdktf_cdktf_provider_azurerm.synapse_workspace_aad_admin",
        "cdktf_cdktf_provider_azurerm.synapse_workspace_extended_auditing_policy",
        "cdktf_cdktf_provider_azurerm.synapse_workspace_key",
        "cdktf_cdktf_provider_azurerm.synapse_workspace_security_alert_policy",
        "cdktf_cdktf_provider_azurerm.synapse_workspace_sql_aad_admin",
        "cdktf_cdktf_provider_azurerm.synapse_workspace_vulnerability_assessment",
        "cdktf_cdktf_provider_azurerm.template_deployment",
        "cdktf_cdktf_provider_azurerm.tenant_template_deployment",
        "cdktf_cdktf_provider_azurerm.traffic_manager_azure_endpoint",
        "cdktf_cdktf_provider_azurerm.traffic_manager_external_endpoint",
        "cdktf_cdktf_provider_azurerm.traffic_manager_nested_endpoint",
        "cdktf_cdktf_provider_azurerm.traffic_manager_profile",
        "cdktf_cdktf_provider_azurerm.user_assigned_identity",
        "cdktf_cdktf_provider_azurerm.video_analyzer",
        "cdktf_cdktf_provider_azurerm.video_analyzer_edge_module",
        "cdktf_cdktf_provider_azurerm.virtual_desktop_application",
        "cdktf_cdktf_provider_azurerm.virtual_desktop_application_group",
        "cdktf_cdktf_provider_azurerm.virtual_desktop_host_pool",
        "cdktf_cdktf_provider_azurerm.virtual_desktop_host_pool_registration_info",
        "cdktf_cdktf_provider_azurerm.virtual_desktop_scaling_plan",
        "cdktf_cdktf_provider_azurerm.virtual_desktop_workspace",
        "cdktf_cdktf_provider_azurerm.virtual_desktop_workspace_application_group_association",
        "cdktf_cdktf_provider_azurerm.virtual_hub",
        "cdktf_cdktf_provider_azurerm.virtual_hub_bgp_connection",
        "cdktf_cdktf_provider_azurerm.virtual_hub_connection",
        "cdktf_cdktf_provider_azurerm.virtual_hub_ip",
        "cdktf_cdktf_provider_azurerm.virtual_hub_route_table",
        "cdktf_cdktf_provider_azurerm.virtual_hub_route_table_route",
        "cdktf_cdktf_provider_azurerm.virtual_hub_routing_intent",
        "cdktf_cdktf_provider_azurerm.virtual_hub_security_partner_provider",
        "cdktf_cdktf_provider_azurerm.virtual_machine",
        "cdktf_cdktf_provider_azurerm.virtual_machine_data_disk_attachment",
        "cdktf_cdktf_provider_azurerm.virtual_machine_extension",
        "cdktf_cdktf_provider_azurerm.virtual_machine_packet_capture",
        "cdktf_cdktf_provider_azurerm.virtual_machine_scale_set",
        "cdktf_cdktf_provider_azurerm.virtual_machine_scale_set_extension",
        "cdktf_cdktf_provider_azurerm.virtual_machine_scale_set_packet_capture",
        "cdktf_cdktf_provider_azurerm.virtual_network",
        "cdktf_cdktf_provider_azurerm.virtual_network_dns_servers",
        "cdktf_cdktf_provider_azurerm.virtual_network_gateway",
        "cdktf_cdktf_provider_azurerm.virtual_network_gateway_connection",
        "cdktf_cdktf_provider_azurerm.virtual_network_gateway_nat_rule",
        "cdktf_cdktf_provider_azurerm.virtual_network_peering",
        "cdktf_cdktf_provider_azurerm.virtual_wan",
        "cdktf_cdktf_provider_azurerm.vmware_cluster",
        "cdktf_cdktf_provider_azurerm.vmware_express_route_authorization",
        "cdktf_cdktf_provider_azurerm.vmware_netapp_volume_attachment",
        "cdktf_cdktf_provider_azurerm.vmware_private_cloud",
        "cdktf_cdktf_provider_azurerm.voice_services_communications_gateway",
        "cdktf_cdktf_provider_azurerm.voice_services_communications_gateway_test_line",
        "cdktf_cdktf_provider_azurerm.vpn_gateway",
        "cdktf_cdktf_provider_azurerm.vpn_gateway_connection",
        "cdktf_cdktf_provider_azurerm.vpn_gateway_nat_rule",
        "cdktf_cdktf_provider_azurerm.vpn_server_configuration",
        "cdktf_cdktf_provider_azurerm.vpn_server_configuration_policy_group",
        "cdktf_cdktf_provider_azurerm.vpn_site",
        "cdktf_cdktf_provider_azurerm.web_app_active_slot",
        "cdktf_cdktf_provider_azurerm.web_app_hybrid_connection",
        "cdktf_cdktf_provider_azurerm.web_application_firewall_policy",
        "cdktf_cdktf_provider_azurerm.web_pubsub",
        "cdktf_cdktf_provider_azurerm.web_pubsub_custom_certificate",
        "cdktf_cdktf_provider_azurerm.web_pubsub_custom_domain",
        "cdktf_cdktf_provider_azurerm.web_pubsub_hub",
        "cdktf_cdktf_provider_azurerm.web_pubsub_network_acl",
        "cdktf_cdktf_provider_azurerm.web_pubsub_shared_private_link_resource",
        "cdktf_cdktf_provider_azurerm.windows_function_app",
        "cdktf_cdktf_provider_azurerm.windows_function_app_slot",
        "cdktf_cdktf_provider_azurerm.windows_virtual_machine",
        "cdktf_cdktf_provider_azurerm.windows_virtual_machine_scale_set",
        "cdktf_cdktf_provider_azurerm.windows_web_app",
        "cdktf_cdktf_provider_azurerm.windows_web_app_slot"
    ],
    "package_data": {
        "cdktf_cdktf_provider_azurerm._jsii": [
            "provider-azurerm@10.0.6.jsii.tgz"
        ],
        "cdktf_cdktf_provider_azurerm": [
            "py.typed"
        ]
    },
    "python_requires": "~=3.7",
    "install_requires": [
        "cdktf>=0.18.0, <0.19.0",
        "constructs>=10.0.0, <11.0.0",
        "jsii>=1.90.0, <2.0.0",
        "publication>=0.0.3",
        "typeguard~=2.13.3"
    ],
    "classifiers": [
        "Intended Audience :: Developers",
        "Operating System :: OS Independent",
        "Programming Language :: JavaScript",
        "Programming Language :: Python :: 3 :: Only",
        "Programming Language :: Python :: 3.7",
        "Programming Language :: Python :: 3.8",
        "Programming Language :: Python :: 3.9",
        "Programming Language :: Python :: 3.10",
        "Programming Language :: Python :: 3.11",
        "Typing :: Typed",
        "Development Status :: 5 - Production/Stable",
        "License :: OSI Approved"
    ],
    "scripts": []
}
"""
)

with open("README.md", encoding="utf8") as fp:
    kwargs["long_description"] = fp.read()


setuptools.setup(**kwargs)
